-- 战技 灵符养成 战技 Panel
checkRequire("Lua_HeroCharmAttrItem");
checkRequire("Lua_HeroCharmSkillItem");
Lua_HeroCharmDevelopSkillPanel = class("Lua_HeroCharmDevelopSkillPanel", Lua_DisplayObject);

function Lua_HeroCharmDevelopSkillPanel:ctor(p)
	self:superCall("ctor", p, "HeroCharmDevelopSkillPanel_skin");
end

function Lua_HeroCharmDevelopSkillPanel:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("UPDATE_HERO_CHARM_INFO", self, self.updateData);

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 185);
end

function Lua_HeroCharmDevelopSkillPanel:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.propItemArr ~= nil then
		self.propItemArr:dispose();
		self.propItemArr = nil;
	end
	if self.skillItemArr ~= nil then
		self.skillItemArr:dispose();
		self.skillItemArr = nil;
	end
	self.heroCharmVo = nil;
	self:superCall("dispose")
end

function Lua_HeroCharmDevelopSkillPanel:setData(charmUid)
	self.charmUid = charmUid;
	self:updateData();
end

function Lua_HeroCharmDevelopSkillPanel:updateData()
	self.heroCharmVo = DataCenter.packData:getItemVoByUnId(self.charmUid);
	self.itemIcon:setData(self.heroCharmVo);
	self.itemIcon:showNum(0);
	
	self:showPropInfo();
	self:showSkillInfo();
end

function Lua_HeroCharmDevelopSkillPanel:showPropInfo()
	if self.propItemArr == nil then
		self.propItemArr = Array();
	end

	local propArr = DataCenter.heroCharmUtil:getComAttrVoArr(self.heroCharmVo.levelId);
	local count = propArr:getSize();
	local item;
	for i = 1, count do
		item = self:getPropItem(i);
		item:setLocation(-215 + (i - 1) % 2 * 200, math.floor((i - 1) / 2) * -50, 0);
		item:setData(propArr[i]);
	end

	propArr = DataCenter.heroCharmUtil:getSpecAttrVoArr(self.heroCharmVo.levelId);
	local limtLv;
	for i = 1, propArr:getSize() do
		item = self:getPropItem(count + i);
		item:setLocation(-215 + (count + i - 1) % 2 * 200, math.floor((count + i - 1) / 2) * -50, 0);

		limtLv = DataCenter.heroCharmUtil:getSpecUnlockLv(self.heroCharmVo.levelId, propArr[i].id);
		item:setData(propArr[i], 1, self.heroCharmVo.level, limtLv);
	end

	count = count + propArr:getSize();
	local len = self.propItemArr:getSize();
	if len > count then
		for i = count + 1, len do
			self.propItemArr[i]:setEnable(false);
		end
	end
end

function Lua_HeroCharmDevelopSkillPanel:getPropItem(idx)
	local item = self.propItemArr[idx];
	if item == nil then
		item = Lua_HeroCharmAttrItem.new(self.content);
		self.propItemArr:add(item);
	else
		item:setEnable(true);
	end
	return item;
end

function Lua_HeroCharmDevelopSkillPanel:showSkillInfo()
	if self.skillItemArr == nil then
		self.skillItemArr = Array();
	end

	local len = 3;
	if self.heroCharmVo == nil then
		for i = 1, len do
			self.skillItemArr[i]:setEnable(false);
		end
		return;
	end

	local item;
	for i = 1, len do
		item = self.skillItemArr[i];
		if item == nil then
			item = Lua_HeroCharmSkillItem.new(self.content);
			item:setLocation(-200 + (i - 1) * 200, -350, 0);
			self.skillItemArr:add(item);
		else
			item:setEnable(true);
		end
		item:setData(self.heroCharmVo, i);
	end
end
