-- 战技 Panel
checkRequire("Lua_HeroCharmAttrItem");
checkRequire("Lua_HeroCharmSkillItem");
Lua_HeroCharmPanel = class("Lua_HeroCharmPanel", Lua_DisplayObject);

function Lua_HeroCharmPanel:ctor(p)
	self:superCall("ctor", p, "HeroCharmPanel_skin");
end

function Lua_HeroCharmPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.viewBtn:addClickFuntion(self, self.onViewBtn);
	self.studyBtn:addClickFuntion(self, self.onStudyBtn);
	self.compoundBtn:addClickFuntion(self, self.onCompoundBtn);

	self.intensifyBtn:addClickFuntion(self, self.onIntensifyBtn);
	self.replaceBtn:addClickFuntion(self, self.onReplaceBtn);
	self.wearBtn:addClickFuntion(self, self.onReplaceBtn);
end

function Lua_HeroCharmPanel:dispose()
	if self.propItemArr ~= nil then
		self.propItemArr:dispose();
		self.propItemArr = nil;
	end
	if self.skillItemArr ~= nil then
		self.skillItemArr:dispose();
		self.skillItemArr = nil;
	end
	self.data = nil;
	self.heroCharmVo = nil;
	self:superCall("dispose")
end

function Lua_HeroCharmPanel:updateHeroPanelInfo(data, isSHowAtlas)
	self.data = data;
	self.heroCharmVo = self.data.heroCharmVo;
	
	local state = self.heroCharmVo ~= nil;
	if state then
		self.nameText.text = self.heroCharmVo.colorName;
		self.levelTxt.text = LanUtil.formateStr("Lv.{1}", self.heroCharmVo.level);
	end
	self.nameBg:setEnable(state);
	self.nameText:setEnable(state);
	self.levelTxt:setEnable(state);
	self.intensifyBtn:setEnable(state);
	self.replaceBtn:setEnable(state);
	self.noneTxt:setEnable(not state);
	self.wearBtn:setEnable(not state);

	self:showPropInfo();
	self:showSkillInfo();
end

function Lua_HeroCharmPanel:showPropInfo()
	if self.propItemArr == nil then
		self.propItemArr = Array();
	end

	local len = self.propItemArr:getSize();
	if self.heroCharmVo == nil then
		for i = 1, len do
			self.propItemArr[i]:setEnable(false);
		end
		return;
	end

	local propArr = DataCenter.heroCharmUtil:getComAttrVoArr(self.heroCharmVo.levelId);
	local count = propArr:getSize();
	local item;
	for i = 1, count do
		item = self:getPropItem(i);
		item:setLocation(-200 + (i - 1) % 2 * 200, -275 - math.floor((i - 1) / 2) * 50, 0);
		item:setData(propArr[i]);
	end

	propArr = DataCenter.heroCharmUtil:getSpecAttrVoArr(self.heroCharmVo.levelId);
	local limtLv;
	for i = 1, propArr:getSize() do
		item = self:getPropItem(count + i);
		item:setLocation(-200 + (count + i - 1) % 2 * 200, -275 - math.floor((count + i - 1) / 2) * 50, 0);

		limtLv = DataCenter.heroCharmUtil:getSpecUnlockLv(self.heroCharmVo.levelId, propArr[i].id);
		item:setData(propArr[i], 1, self.heroCharmVo.level , limtLv);
	end

	count = count + propArr:getSize();
	if len > count then
		for i = count + 1, len do
			self.propItemArr[i]:setEnable(false);
		end
	end
end

function Lua_HeroCharmPanel:getPropItem(idx)
	local item = self.propItemArr[idx];
	if item == nil then
		item = Lua_HeroCharmAttrItem.new(self.content);
		self.propItemArr:add(item);
	else
		item:setEnable(true);
	end
	return item;
end

function Lua_HeroCharmPanel:showSkillInfo()
	if self.skillItemArr == nil then
		self.skillItemArr = Array();
	end

	local len = 3;
	if self.heroCharmVo == nil then
		for i = 1, len do
			if self.skillItemArr[i] ~= nil then
				self.skillItemArr[i]:setEnable(false);
			end
		end
		return;
	end

	local item;
	for i = 1, len do
		item = self.skillItemArr[i];
		if item == nil then
			item = Lua_HeroCharmSkillItem.new(self.content);
			item:setLocation(-200 + (i - 1) * 200, -420, 0);
			self.skillItemArr:add(item);
		else
			item:setEnable(true);
		end
		item:setData(self.heroCharmVo, i);
	end
end

function Lua_HeroCharmPanel:onViewBtn()
	Lua_WindowUtil.openWin("Lua_HeroCharmSkillViewWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

function Lua_HeroCharmPanel:onStudyBtn()
	Lua_WindowUtil.openWin("Lua_HeroCharmSlotWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_HeroCharmPanel:onCompoundBtn()
	Lua_WindowUtil.openWin("Lua_RunesCompoundWindow", Lua_WinParam.ACTION_OPEN, 2);
end

function Lua_HeroCharmPanel:onIntensifyBtn()
	local param = {charmUid = self.heroCharmVo.unique_id, index = 2};
	Lua_WindowUtil.openWin("Lua_HeroCharmDevelopWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_HeroCharmPanel:onReplaceBtn()
	Lua_WindowUtil.openWin("Lua_HeroCharmReplaceWindow", Lua_WinParam.ACTION_OPEN, self.data);
end