-- 战技 灵符更换 Window
checkRequire("Lua_HeroCharmAttrItem");
Lua_HeroCharmReplaceWindow = class("Lua_HeroCharmReplaceWindow", Lua_Window);

function Lua_HeroCharmReplaceWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
    self.isClickClose = true;
    
	self.windowName = "Lua_HeroCharmReplaceWindow";
	self.skinName = "HeroCharmReplaceWindow_skin";
end

function Lua_HeroCharmReplaceWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("UPDATE_CHARM_CHANGE", self, self.updateData);
	self:addLuaEvent("ON_CHARM_WEAR_UPDATE", self, self.onWearEvent);
end

function Lua_HeroCharmReplaceWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 629, 565, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_HeroCharmReplaceItem, 629, 145, 1);
	self.dragList:setCellSpacing(0, 0);
	self.dragList:setLocation(0, -140);

	self.goTxt:addClickFuntion(self, self.onGoTxtClick);
end

function Lua_HeroCharmReplaceWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self.heroVo = nil;
	self.heroCharmVo = nil;
	self:superCall("dispose");
end

function Lua_HeroCharmReplaceWindow:showWin(param)
	self.heroVo = param;
	self:updateData();
end

function Lua_HeroCharmReplaceWindow:updateData()
	local heroCharmData = DataCenter.heroCharmData;
	self.heroCharmVo = self.heroVo.heroCharmVo;

	local isShow = self.heroCharmVo == nil;
	if not isShow then
		if self.showItem == nil then
			self.showItem = Lua_HeroCharmReplaceItem.new(self.content, true);
			self.showItem:setLocation(0, 245, 0);
		end
		self.showItem:setData(self.heroCharmVo);
		self.showItem:setEnable(true);
	else
		if self.showItem ~= nil then
			self.showItem:setEnable(false);
		end
	end
	self.wearBg:setEnable(isShow);
	self.wearTxt:setEnable(isShow);
	self.goTxt:setEnable(isShow);

	local uid = isShow and 0 or self.heroCharmVo.unique_id;
	local arr = heroCharmData:getCharmVoArr(uid);
	self.dragList:setArrayData(arr);

	isShow = arr:getSize() <= 0;
	self.noneBg:setEnable(isShow);
	self.noneTxt:setEnable(isShow);
end

function Lua_HeroCharmReplaceWindow:onGoTxtClick()
	DataCenter.packUtil:openPathWindow(Lua_PackDefine.NOMAL_CHARM, false);
end

function Lua_HeroCharmReplaceWindow:onWearEvent(charmUid)
	if self.heroCharmVo ~= nil and self.heroCharmVo.unique_id == charmUid then
		Lua_ProxyManager.getProxy("Lua_HeroCharmProxy"):sCharmChange(0, charmUid);
	else
		Lua_ProxyManager.getProxy("Lua_HeroCharmProxy"):sCharmChange(self.heroVo.unique_id, charmUid);
	end 
end

























Lua_HeroCharmReplaceItem = class("Lua_HeroCharmReplaceItem", Lua_ListCell);

function Lua_HeroCharmReplaceItem:ctor(p, isSelf)
	self.isSelf = isSelf;
	self:superCall("ctor", p, "HeroCharmReplaceItem_skin");
end

function Lua_HeroCharmReplaceItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.85, 0.85);
	self.itemIcon:setLocation(-237, 0, 0);
	self.itemIcon:setCanClick(true);

	self.changeBtn:addClickFuntion(self, self.onChangeBtnClick);
end

function Lua_HeroCharmReplaceItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.propItemArr ~= nil then
		self.propItemArr:dispose();
		self.propItemArr = nil;
	end
	if self.skillItemArr ~= nil then
		self.skillItemArr:dispose();
		self.skillItemArr = nil;
	end
	if self.wearAvatar ~= nil then
		self.wearAvatar:dispose();
		self.wearAvatar = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroCharmReplaceItem:setData(data)
	self.data = data;

	self.nameTxt.text = data.name;
	self.itemIcon:setData(data);
	self.itemIcon:showNum(0);

	local state = self.data.heroUid > 0;
	if state then
		if self.wearAvatar == nil then
			self.wearAvatar = Lua_AvatarItem.new(self.content);
			self.wearAvatar:setAvatarBg("common_altas_3", "xui_common_widget_019", 0.3);
			self.wearAvatar:setLocation(156, -43, 0);
		end
		local heroVo = self.data.heroVo;
		self.wearAvatar:setHeroAvatar(heroVo.id, 0.27, heroVo.clothesId);
		self.wearTxt.text = LanUtil.formateStr("{1}装备中", heroVo.name);
		if self.isSelf then
			self.changeBtn.label = "卸下";
		else
			self.changeBtn.label = "更换";
		end
	else
		if self.wearAvatar ~= nil then
			self.wearAvatar:setEnable(false);
		end
		self.changeBtn.label = "穿戴";
	end
	self.wearBg:setEnable(state);
	self.wearTxt:setEnable(state);

	self:showPropInfo();
	self:showSkillInfo();
end

function Lua_HeroCharmReplaceItem:showPropInfo()
	if self.propItemArr == nil then
		self.propItemArr = Array();
	end

	local propArr = DataCenter.heroCharmUtil:getComAttrVoArr(self.data.levelId);
	local count = propArr:getSize();
	local item;
	for i = 1, count do
		item = self:getPropItem(i);
		item:setLocation(-165 + (i - 1) % 2 * 160, 10 - math.floor((i - 1) / 2) * 30, 0);
		item:setData(propArr[i]);
	end

	propArr = DataCenter.heroCharmUtil:getSpecAttrVoArr(self.data.levelId);
	local limtLv;
	for i = 1, propArr:getSize() do
		item = self:getPropItem(count + i);
		item:setLocation(-165 + (count + i - 1) % 2 * 160, 10 - math.floor((count + i - 1) / 2) * 30, 0);

		limtLv = DataCenter.heroCharmUtil:getSpecUnlockLv(self.data.levelId, propArr[i].id);
		item:setData(propArr[i], 1, self.data.level , limtLv);
	end

	count = count + propArr:getSize();
	local len = self.propItemArr:getSize();
	if len > count then
		for i = count + 1, len do
			self.propItemArr[i]:setEnable(false);
		end
	end
end

function Lua_HeroCharmReplaceItem:getPropItem(idx)
	local item = self.propItemArr[idx];
	if item == nil then
		item = Lua_HeroCharmAttrItem.new(self.content);
		self.propItemArr:add(item);
	else
		item:setEnable(true);
	end
	return item;
end

function Lua_HeroCharmReplaceItem:showSkillInfo()
	if self.skillItemArr == nil then
		self.skillItemArr = Array();
	end
	
	local list = self.data.slotList;
	local item;
	local lvlId;
	local index = 1;
	for i = 1, #list do
		item = self.skillItemArr[i];
		if item == nil then
			item = Lua_HeroCharmSkillNameItem.new(self.content);
			self.skillItemArr:add(item);
		end

		lvlId = list[i].value;
		if lvlId > 0 then
			item:setData(lvlId);
			item:setLocation(-135 + (index - 1) * 100, -45, 0);
			index = index + 1;
		end
		item:setEnable(lvlId > 0);
	end
end

function Lua_HeroCharmReplaceItem:onChangeBtnClick()
	Lua_MsgUtil.callFunc("ON_CHARM_WEAR_UPDATE", self.data.unique_id);
end


































Lua_HeroCharmSkillNameItem = class("Lua_HeroCharmSkillNameItem", Lua_DisplayObject);

function Lua_HeroCharmSkillNameItem:ctor(p)
	self:superCall("ctor", p, "HeroCharmSkillNameItem_skin");
end

function Lua_HeroCharmSkillNameItem:buildShowItem()
	self:superCall("buildShowItem");
	self.nameTxt:addClickFuntion(self, self.onNameTxtClick);
end

function Lua_HeroCharmSkillNameItem:dispose()
	self.data = nil;
	self:superCall("dispose")
end

function Lua_HeroCharmSkillNameItem:setData(lvlId)
	self.data = Lua_HeroCharmSlotLvData.getConfigData(lvlId);
	self.nameTxt.text = LanUtil.formateStr("<u>{1}</u>", self.data.skillData.name);
end

function Lua_HeroCharmSkillNameItem:onNameTxtClick()
	Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.data.skillData);
end