-- 战技 item
Lua_HeroCharmSkillItem = class("Lua_HeroCharmSkillItem", Lua_DisplayObject);

function Lua_HeroCharmSkillItem:ctor(p)
	self:superCall("ctor", p, "HeroCharmSkillItem_skin");
end

function Lua_HeroCharmSkillItem:buildShowItem()
	self:superCall("buildShowItem");

	self.skillBg.clickScale = false;
	self.skillBg:addClickFuntion(self, self.onClick);
end

function Lua_HeroCharmSkillItem:dispose()
	self:superCall("dispose")
end

-- showState: 0:未解锁 1：未穿戴 2：已穿戴
function Lua_HeroCharmSkillItem:setData(charmVo, idx)
	self.charmVo = charmVo;
	self.idx = idx;

	self.state = charmVo:getSlotState(idx);
	if self.state == 1 then
		self.nameTxt.text = "请选择一个战技";
	elseif self.state == 2 then
		local lvlId = charmVo:getSlotLvId(idx);
		local data = Lua_HeroCharmSlotLvData.getConfigData(lvlId);
		self.skillData = data.skillData;
		self.nameTxt.text = LanUtil.formateStr("{1} Lv.{2}", self.skillData.name, self.skillData.level);
		self.skillIcon:setAltas(self.skillData.atlas, self.skillData.sprite);
	end

	self.addIcon:setEnable(self.state == 1);
	self.skillIcon:setEnable(self.state == 2);
	self.maskBg:setEnable(self.state == 0);
	self.lockIcon:setEnable(self.state == 0);
	self.nameTxt:setEnable(self.state ~= 0);
end

function Lua_HeroCharmSkillItem:onClick()
	if self.state == 0 then
		OperateAlert.show("该灵符技能不可用");
	elseif self.state == 1 then
		local param = {charmVo = self.charmVo, idx = self.idx};
		Lua_WindowUtil.openWin("Lua_HeroCharmSkillSelectWindow", Lua_WinParam.ACTION_OPEN, param);
	elseif self.state == 2 then
		local param = {skillVo = self.skillData, charmUid = self.charmVo.unique_id, idx = self.idx};
		Lua_WindowUtil.openWin("Lua_HeroCharmSkillTipsWindow", Lua_WinParam.ACTION_OPEN, param);
	end
end