-- 战技 技能更换 Window
Lua_HeroCharmSkillSelectWindow = class("Lua_HeroCharmSkillSelectWindow", Lua_Window);

function Lua_HeroCharmSkillSelectWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
    self.isClickClose = true;

	self.windowName = "Lua_HeroCharmSkillSelectWindow";
	self.skinName = "HeroCharmSkillSelectWindow_skin";
end

function Lua_HeroCharmSkillSelectWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("UPDATE_HERO_CHARM_INFO", self, self.updateData);
	self:addLuaEvent("ON_CHARM_SKILL_SELECT_UPDATE", self, self.onSelectEvent);
end

function Lua_HeroCharmSkillSelectWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 590, 672, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_HeroCharmSkillSelectItem, 138, 160, 4);
	self.dragList:setCellSpacing(13, 19);
	self.dragList:setLocation(0, -35);

	local btnInfoArr = Array();
	btnInfoArr:add({textStr = "全部", skillType = 0});
	btnInfoArr:add({textStr = "攻击", skillType = 1});
	btnInfoArr:add({textStr = "防御", skillType = 2});
    btnInfoArr:add({textStr = "辅助", skillType = 3});

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.btnList:setLocation(0, -438, 0);
    self.btnList:setButtonStyle("common_altas_1", "xui_common_button_006_n", "xui_common_button_006_n", 150, 56, 0.01, 1);
    self.btnList:setButtonText(0, 1, "594d4d", "8f5123", 28, 28, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.btnList:setButtonItem(130, 56);
    self.btnList:setClickCallBack(self, self.onBtnClick);
    self.btnList:setData(btnInfoArr);

    self.tipBtn:addClickFuntion(self, self.onTipBtnClick);
end

function Lua_HeroCharmSkillSelectWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	self.charmVo = nil;
	self:superCall("dispose");
end

function Lua_HeroCharmSkillSelectWindow:showWin(param)
	if param == nil then
		self:hide();
		return;
	end
	self.charmVo = param.charmVo;
	self.idx = param.idx;
	self.color = self.charmVo:getSlotColor(self.idx);

	self.dragList.customParam = self.charmVo;
	self.btnList:setSelected(1);
end

function Lua_HeroCharmSkillSelectWindow:onBtnClick(idx, data)
	self.skillType = data.skillType;
	self:updateData();
end

function Lua_HeroCharmSkillSelectWindow:updateData()
	local arr = DataCenter.heroCharmData:getActiveSkillArr(self.skillType, self.color);
	self.dragList:setArrayData(arr);
end

function Lua_HeroCharmSkillSelectWindow:onSelectEvent(data)
	local idx = self.charmVo:getSlotIdx(data.id);
	if idx > 0 then
		local param = {skillVo = data.skillData, charmUid = self.charmVo.unique_id, idx = self.idx};
		Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, param);
	else
		Lua_ProxyManager.getProxy("Lua_HeroCharmProxy"):sCharmSkillChange(self.charmVo.unique_id, self.idx, data.id);
		OperateAlert.show("技能更换成功");
	end
end

function Lua_HeroCharmSkillSelectWindow:onTipBtnClick()
	local tipsData = {des = "描述提示", posX = -35, posY = 370, needAdapt = false};
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end


























Lua_HeroCharmSkillSelectItem = class("Lua_HeroCharmSkillSelectItem", Lua_ListCell);

function Lua_HeroCharmSkillSelectItem:ctor(p)
    self:superCall("ctor", p, "HeroCharmSkillSelectItem_skin");
end

function Lua_HeroCharmSkillSelectItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroCharmSkillSelectItem:dispose()
    self:superCall("dispose");
end

function Lua_HeroCharmSkillSelectItem:setCustomParam(customParam)
	self.charmVo = customParam;
end

function Lua_HeroCharmSkillSelectItem:setData(data)
	self.data = data;

	local skillData = data.skillData;
	self.nameTxt.text = LanUtil.formateStr("{1} Lv.{2}", skillData.name, skillData.level);
	self.skillIcon:setAltas(skillData.atlas, skillData.sprite);

	local idx = self.charmVo:getSlotIdx(data.id);
	if idx > 0 then
		self.wearTxt.text = LanUtil.formateStr("槽位{1}\n穿戴中", idx);
	end
	self.maskBg:setEnable(idx > 0);
	self.wearTxt:setEnable(idx > 0);
end

function Lua_HeroCharmSkillSelectItem:onPressClick()
    Lua_MsgUtil.callFunc("ON_CHARM_SKILL_SELECT_UPDATE", self.data);
end