-- 战技 技能预览 Window
Lua_HeroCharmSkillShowWindow = class("Lua_HeroCharmSkillShowWindow", Lua_Window);

function Lua_HeroCharmSkillShowWindow:ctor()
	self:superCall("ctor");

	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
    self.showBlackMask = true;
    self.isClickClose = true;

	self.windowName = "Lua_HeroCharmSkillShowWindow";
	self.skinName = "HeroCharmSkillShowWindow_skin";
end

function Lua_HeroCharmSkillShowWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 590, 672, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_HeroCharmSkillShowItem, 138, 160, 4);
	self.dragList:setCellSpacing(13, 19);
	self.dragList:setLocation(0, -35);

	local btnInfoArr = Array();
	btnInfoArr:add({textStr = "初级", color = 3});
	btnInfoArr:add({textStr = "中级", color = 4});
	btnInfoArr:add({textStr = "高级", color = 5});
    btnInfoArr:add({textStr = "顶级", color = 6});

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.btnList:setLocation(0, -438, 0);
    self.btnList:setButtonStyle("common_altas_1", "xui_common_button_006_n", "xui_common_button_006_n", 150, 56, 0.01, 1);
    self.btnList:setButtonText(0, 1, "594d4d", "8f5123", 28, 28, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.btnList:setButtonItem(130, 56);
    self.btnList:setClickCallBack(self, self.onBtnClick);
    self.btnList:setData(btnInfoArr);
    self.btnList:setSelected(1);

    self.tipBtn:addClickFuntion(self, self.onTipBtnClick);
end

function Lua_HeroCharmSkillShowWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroCharmSkillShowWindow:onBtnClick(idx, data)
	self.color = data.color;
	self:updateData();
end

function Lua_HeroCharmSkillShowWindow:updateData()
	local arr = DataCenter.heroCharmData:getSlotIdArr(self.color);
	self.dragList:setArrayData(arr);
end

function Lua_HeroCharmSkillShowWindow:onTipBtnClick()
	local tipsData = {des = "描述提示", posX = -35, posY = 370, needAdapt = false};
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end


























Lua_HeroCharmSkillShowItem = class("Lua_HeroCharmSkillShowItem", Lua_ListCell);

function Lua_HeroCharmSkillShowItem:ctor(p)
    self:superCall("ctor", p, "HeroCharmSkillShowItem_skin");
end

function Lua_HeroCharmSkillShowItem:buildShowItem()
    self:superCall("buildShowItem");

    self.skillIcon = Lua_SkillIconItem.new(self.content);
    self.skillIcon:setLocation(0,16,0);
end

function Lua_HeroCharmSkillShowItem:dispose()
    if self.skillIcon ~= nil then
        self.skillIcon:dispose() 
        self.skillIcon = nil;
    end
	self.skillData = nil;
    self:superCall("dispose");
end

function Lua_HeroCharmSkillShowItem:setData(slotId)
	local data = DataCenter.heroCharmData:getSlotVo(slotId);
	self.skillData = data.preLvlData.skillData;
	self.skillIcon:setData(self.skillData);
	self.skillIcon:setRarityIcon(self.skillData.rarity);
	self.nameTxt.text = LanUtil.formateStr("{1} Lv.{2}", self.skillData.name, self.skillData.level);
end

function Lua_HeroCharmSkillShowItem:onPressClick()
    Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.skillData);
end