-- 战技 技能总览 Window
Lua_HeroCharmSkillViewWindow = class("Lua_HeroCharmSkillViewWindow", Lua_Window);

function Lua_HeroCharmSkillViewWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
    self.isClickClose = true;

	self.windowName = "Lua_HeroCharmSkillViewWindow";
	self.skinName = "HeroCharmSkillViewWindow_skin";
end

function Lua_HeroCharmSkillViewWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.runeList = Lua_DragList.new(self.content, 600, 180, Lua_AxisDefine.Horizontal);
	self.runeList:setListCell(Lua_HeroCharmSkillViewItem, 180, 180, 1);
	self.runeList:setCellSpacing(0, 0);
	self.runeList:setLocation(0, 100);

	self.charmList = Lua_DragList.new(self.content, 600, 180, Lua_AxisDefine.Horizontal);
	self.charmList:setListCell(Lua_HeroCharmSkillViewItem, 180, 180, 1);
	self.charmList:setCellSpacing(0, 0);
	self.charmList:setLocation(0, -160);
end

function Lua_HeroCharmSkillViewWindow:dispose()
	if self.runeList ~= nil then
		self.runeList:dispose();
		self.runeList = nil;
	end
	if self.charmList ~= nil then
		self.charmList:dispose();
		self.charmList = nil;
	end
	self.heroVo = nil;
	self:superCall("dispose");
end

function Lua_HeroCharmSkillViewWindow:showWin(param)
	self.heroVo = param;
	self:updateData();
end

function Lua_HeroCharmSkillViewWindow:updateData()
	local skillVoArr = Array();
	local list = self.heroVo.runsTipsInfo;
	local vo;
	local idList;
	local skillVo;
	for i = 1, #list do
		if list[i] ~= nil then
			if type(list[i]) == "number" then
				vo = DataCenter.runesData:getRunesVoByUid(list[i]) or {};
			else
				vo = list[i];
			end
			
			idList = vo.rune_skill_list
			if idList ~= nil then
				for j = 1, #idList do
					skillVo = Lua_SkillConfigData.getConfigData(idList[j]);
					skillVoArr:add(skillVo);
				end
			end
		end
	end
	skillVoArr:sortf(self, self.onSort);
	self.runeList:setArrayData(skillVoArr);
	self.noneTxt_1:setEnable(skillVoArr:getSize() <= 0);

	local heroCharmVo = self.heroVo.heroCharmVo;
	skillVoArr = Array();
	if heroCharmVo ~= nil then
		for i = 1, 3 do
			vo = heroCharmVo:getSlotLvData(i);
			if vo ~= nil then
				skillVo = Lua_SkillConfigData.getConfigData(vo.skill);
				skillVoArr:add(skillVo);
			end
		end
	end
	skillVoArr:sortf(self, self.onSort);
	self.charmList:setArrayData(skillVoArr);
	self.noneTxt_2:setEnable(skillVoArr:getSize() <= 0);
end

function Lua_HeroCharmSkillViewWindow:onSort(a, b)
	if a.level < b.level then
		return true;
	elseif a.level == b.level then
		return a.skillId > b.skillId;
	end
	return false;
end



























Lua_HeroCharmSkillViewItem = class("Lua_HeroCharmSkillViewItem", Lua_ListCell);

function Lua_HeroCharmSkillViewItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroCharmSkillViewItem:buildShowItem()
    self:superCall("buildShowItem");

    self.skillIcon = Lua_SkillIconItem.new(self.content);
    self.skillIcon:setLocation(0,0,0);

    self.nameTxt = UICreate.createLabel(self.content, "", 0, -70, 100, 30, 22);
    self.nameTxt.alignmentValue = 4;
    self.nameTxt.horizontalOverflowValue = 1;
end

function Lua_HeroCharmSkillViewItem:dispose()
	if self.skillIcon ~= nil then
		self.skillIcon:dispose();
		self.skillIcon = nil;
	end
	if self.nameTxt ~= nil then
		self.nameTxt:dispose();
		self.nameTxt = nil;
	end
    self:superCall("dispose");
end

function Lua_HeroCharmSkillViewItem:setData(skillVo)
	self.skillVo = skillVo;
	self.skillIcon:setData(skillVo);
	self.nameTxt.text = LanUtil.formateStr("<color=#37D652>{1} Lv.{2}</color>", skillVo.name, skillVo.level);
end

function Lua_HeroCharmSkillViewItem:onPressClick()
    Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.skillVo);
end