-- 战技 技能重置 Window
Lua_HeroCharmSlotResetWindow = class("Lua_HeroCharmSlotResetWindow", Lua_Window);

function Lua_HeroCharmSlotResetWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
    self.isClickClose = true;

	self.windowName = "Lua_HeroCharmSlotResetWindow";
	self.skinName = "HeroCharmSlotResetWindow_skin";
end

function Lua_HeroCharmSlotResetWindow:buildShowItem()
	self:superCall("buildShowItem")

	self:addLuaEvent("UPDATE_CHARM_SKILL_RESET", self, self.updateData);

	self.helpTxt.text = "注:重置后若不满足前置学习条件，则暂时无法学习对应技能";

	self.costList = DataCenter.heroCharmUtil.rebirth_cost;

	self.itemList = Lua_DragList.new(self.content, 623, 234, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(8, -15, 0);
	self.itemList:setListCell(Lua_ItemIconCell, 112, 112, 5);
	self.itemList:setCellSpacing(12, 15);

	self.tipIcon:addClickFuntion(self, self.onTipTconClick);
	self.cancelBtn:addClickFuntion(self, self.hide);
	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);

	Lua_ProxyManager.getProxy("Lua_HeroCharmProxy"):sCharmSkillReset(0);
end

function Lua_HeroCharmSlotResetWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroCharmSlotResetWindow:showWin(param)
	self.curSlotVo = param;
end

function Lua_HeroCharmSlotResetWindow:updateData()
	local skillVo = self.curSlotVo.skillData;
	local packNum = DataCenter.packData:getItemCountById(self.costList[1][1]);
	self.isMeet = packNum >= self.costList[1][2];
	self.tipTxt.text = LanUtil.formateStr("是否消耗{1}x{2}(拥有: {3})将{4}重置为0级, 同时100%返还消耗的材料",
		spliceIconStrById(self.costList[1][1]), self.costList[1][2], packNum, skillVo.name);

	local arr = DataCenter.heroCharmUtil:getLvUpCostArr(self.curSlotVo.levelId);
	self.itemList:setArrayData(arr);

	self.promptTxt.text = LanUtil.formateStr("本周剩余重置次数：{1}次", DataCenter.heroCharmData.resetTime);
end

function Lua_HeroCharmSlotResetWindow:onTipTconClick(go)
	local param = { des = "描述", posX = 180, posY = -375 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_HeroCharmSlotResetWindow:onSureBtnClick()
	if DataCenter.heroCharmData.resetTime <= 0 then
		OperateAlert.show("剩余重置次数不足");
		return;
	end

	if self.isMeet then
		Lua_ProxyManager.getProxy("Lua_HeroCharmProxy"):sCharmSkillReset(self.curSlotVo.id);
		self:hide();
	else
		OperateAlert.show("消耗道具不足");
	end
end