-- 战技 技能提升 Window
Lua_HeroCharmSlotUpWindow = class("Lua_HeroCharmSlotUpWindow", Lua_Window);

function Lua_HeroCharmSlotUpWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_HeroCharmSlotUpWindow";
	self.skinName = "HeroCharmSlotUpWindow_skin";
end

function Lua_HeroCharmSlotUpWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroCharmSlotUpWindow:dispose()
	if self.costItemArr ~= nil then
		self.costItemArr:dispose();
		self.costItemArr = nil;
	end
	if self.desItem ~= nil then
		self.desItem:dispose();
		self.desItem = nil;
	end
	if self.btnArr ~= nil then
		self.btnArr:dispose();
		self.btnArr = nil;
	end
	self.curSlotVo = nil;
	self:superCall("dispose");
end

function Lua_HeroCharmSlotUpWindow:showWin(param)
	self.curSlotVo = param;

	local curLvData = self.curSlotVo.levelData;
	local nextLvData;
	local skillVo;
	local list;
	if self.curSlotVo.level > 0 then
		if self.curSlotVo.level >= self.curSlotVo.max_level then
			list = {2};
			nextLvData = {};
		else
			list = {2, 3};
			nextLvData = Lua_HeroCharmSlotLvData.getConfigData(self.curSlotVo.levelId + 1);
		end
		skillVo = curLvData.skillData;
	else
		list = {1};
		nextLvData = self.curSlotVo.preLvlData;
		skillVo = nextLvData.skillData;
	end

	self.skillIcon:setAltas(skillVo.atlas, skillVo.sprite);
	self.nameTxt.text = skillVo.name;
	self.skillTypeTxt.text = skillVo.skillTypeName;
	if skillVo.skillType == 2 and skillVo.show_cool_round <= 0 then
		self.coolTxt:setLangValue(126120);
	else
		self.coolTxt.text = LanUtil.formateStr(126105, tostring(skillVo.cool_round));
	end

	self.desItem = Lua_HeroCharmSlotUpDesItem.new(self.content);
	self.desItem:setLocation(0, 220, 0);
	self.desItem:setData(curLvData, nextLvData);

	self:showCostInfo();
	self:createButton(list);
end

function Lua_HeroCharmSlotUpWindow:showCostInfo()
	if self.costItemArr == nil then
		self.costItemArr = Array();
	end

	if self.curSlotVo.level < self.curSlotVo.max_level then
		local lvData = self.curSlotVo.level > 0 and Lua_HeroCharmSlotLvData.getConfigData(self.curSlotVo.levelId + 1) or self.curSlotVo.preLvlData;
		local list = lvData.unlock_task;
		local isCondMeet = true;
		if list ~= nil then
			local des = "";
			local curNum;
			local colorStr;
			local lastSlotVo = DataCenter.heroCharmData:getSlotVo(self.curSlotVo.id - 1);
			for i = 1, #list do
				if list[i][1] == 1 then
					curNum = lastSlotVo ~= nil and lastSlotVo.level or 0;
					colorStr = curNum >= list[i][2] and "FFFFFF" or "ED4C30";
					des = des .. LanUtil.formateStr("上一品质同名技能槽等级达到<color=#{1}>{2}/{3}</color>", colorStr, curNum, list[i][2]);
				elseif list[i][1] == 2 then
					curNum = DataCenter.heroCharmData:getSlotColorLv(lvData.color - 1);
					colorStr = curNum >= list[i][2] and "FFFFFF" or "ED4C30";
					des = des .. LanUtil.formateStr("上一品质技能池的技能槽总等级达到<color=#{1}>{2}/{3}</color>", colorStr, curNum, list[i][2]);
				end

				if curNum < list[i][2] then
					isCondMeet = false;
				end
			end
			self.condTxt.text = des;
		end
		self.condTxt:setEnable(list ~= nil);

		list = lvData.unlock_cost;
		self.isMeetCond = isCondMeet;
		self.isMeetCost = DataCenter.packData:checkConsumeEnough(list);
		if list ~= nil then
			local vo;
			local des = "";
			local packNum;
			local colorStr;
			local index = 0;
			local item;
			for i = 1, #list do
				vo = Lua_ToolVo.createToolVo(list[i][1]);
				packNum = DataCenter.packData:getItemCountById(vo.id);
				if vo.main_type == Lua_PackDefine.RESOURCE then
					colorStr = packNum >= list[i][2] and "FFFFFF" or "ED4C30";
					des = des .. "   " .. LanUtil.formateStr("{1}<color=#{2}>{3}/{4}</color>", spliceIconStrById(vo.id), 
						colorStr, numberTrans(packNum), numberTrans(list[i][2]));
				else
					index = index + 1;
					item = self.costItemArr[index];
					if item == nil then
						item = Lua_ItemIcon.new(self.cotent);
						self.costItemArr:add(item);
					end
					item:setData(vo);
					item:showNumLimit(1, packNum, list[i][2]);
				end
			end
			self.costTxt.text = des;

			local halfW = (index - 1) * 100 / 2;
			local count = self.costItemArr:getSize();
			for i = 1, count do
				item = self.costItemArr[i];
				if i <= index then
					item:setLocation(0 + (i - 1) * 100 - halfW, 0, 0);
				end
				item:setEnable(i <= index);
			end
		end
	end
	self.upObj:SetActive(self.curSlotVo.level < self.curSlotVo.max_level);
end

function Lua_HeroCharmSlotUpWindow:createButton(list)
    if self.btnArr == nil then
        self.btnArr = Array();
    end

    local len = #list;
    local num = self.btnArr:getSize();
    local count = len > num and len or num;
    local item;
    local nameStr;
    local btnWidth = 450 / len;
    for i = 1, count do
        item = self.btnArr[i];
        if item == nil then
            item = UICreate.createButton(self.content, nil, 0, 0, 141, 54);
            item:setStyle(14);
            item.txt:setLocation(0, 0, 0);
            item.txt.fontSize = 28;
            item:addClickFuntion(self, self.onBtnClick);
            self.btnArr:add(item); 
        end

        if len >= i then
            nameStr = self:getBtnName(list[i]);
            item.label = nameStr;
            item.name = list[i];
            item:setLocation((i - 1) * btnWidth - (len - 1) / 2 * btnWidth, -345, 0);
        end
        item:setEnable(len >= i);
    end
end

function Lua_HeroCharmSlotUpWindow:getBtnName(t)
    if t == 1 then
        return "解锁";
    elseif t == 2 then
        return "重置";
    elseif t == 3 then
    	return "升级";
   	end
    return "";
end

function Lua_HeroCharmSlotUpWindow:onBtnClick(go)
    if tonumber(go.name) == 1 or tonumber(go.name) == 3 then
    	if self.isMeetCond then
    		if self.isMeetCost == nil then
    			Lua_ProxyManager.getProxy("Lua_HeroCharmProxy"):sCharmSkillUpgrade(self.curSlotVo.id);
    		else
    			DataCenter.packUtil:openPathWindow(self.isMeetCost);
    		end
    	else
    		OperateAlert.show("未满足前置条件");
    	end
    elseif tonumber(go.name) == 2 then
    	Lua_WindowUtil.openWin("Lua_HeroCharmSlotResetWindow", Lua_WinParam.ACTION_OPEN, self.curSlotVo);
    end
    self:hide();
end


























Lua_HeroCharmSlotUpDesItem = class("Lua_HeroCharmSlotUpDesItem", Lua_DisplayObject);

function Lua_HeroCharmSlotUpDesItem:ctor(p)
	self:superCall("ctor", p, "HeroCharmSlotUpDesItem_skin");
end

function Lua_HeroCharmSlotUpDesItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroCharmSlotUpDesItem:dispose()
	self:superCall("dispose")
end

function Lua_HeroCharmSlotUpDesItem:setData(curLvData, nextLvData)
	local curPosY = -30;
	if curLvData ~= nil then
		self.curDesTxt.text = curLvData.skillData.des;
		self.curDesTxt:resetSize();
		curPosY = curPosY - 30 - self.curDesTxt.height;
	end
	self.curLvTxt:setEnable(curLvData ~= nil);
	self.curDesTxt:setEnable(curLvData ~= nil);

	if nextLvData ~= nil then
		self.nextDesTxt.text = nextLvData.skillData.des;
		self.nextDesTxt:resetSize();
		self.nextLvTxt:setLocation(0, curPosY, 0);
		self.nextDesTxt:setLocation(0, curPosY - 30, 0);
		curPosY = curPosY - 30 - self.nextDesTxt.height;

		self.addTxt.text = "全体英雄属性加成";
	else
		self.addTxt.text = "全体英雄下级属性加成";
	end
	self.nextLvTxt:setEnable(nextLvData ~= nil);
	self.nextDesTxt:setEnable(nextLvData ~= nil);

	local propList = nextLvData == nil and curLvData.add_prop or nextLvData.add_prop;
	local dic = DataCenter.attributesUtil:getAttrDic(propList);
	local arr = DataCenter.attributesUtil:getAttrArrByDic(dic);
	local str = "";
	for i = 1, arr:getSize() do
		str = str .. LanUtil.formateStr("{1}+{2}\n", arr[i].show_name, arr[i].value);
	end
	self.propTxt.text = str;
	self.propTxt:resetSize();
	self.addTxt:setLocation(0, curPosY, 0);
	self.propTxt:setLocation(0, curPosY - 30, 0);
	
	curPosY = curPosY - 30 - self.propTxt.height;
	self.addHeight = Mathf.Abs(curPosY);
end

function Lua_HeroCharmSlotUpDesItem:getWidth()
    return 420;
end

function Lua_HeroCharmSlotUpDesItem:getHeight()
    return self.addHeight;
end