-- 战技 技能研究 Window
checkRequire("Lua_HeroCharmAttrItem");
Lua_HeroCharmSlotWindow = class("Lua_HeroCharmSlotWindow", Lua_Window);

function Lua_HeroCharmSlotWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
    self.showBackBtn = true;
    self.showWinBg = true;
    self.winBgPath = "/images/common/ui_common_bg_001.jpg";

	self.windowName = "Lua_HeroCharmSlotWindow";
	self.skinName = "HeroCharmSlotWindow_skin";
end

function Lua_HeroCharmSlotWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("UPDATE_CHARM_SKILL_UPGRADE", self, self.updateData);
	self:addLuaEvent("UPDATE_CHARM_SKILL_RESET", self, self.updateData);

	self.dragList = Lua_DragList.new(self.content, 590, 700, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_HeroCharmSlotItem, 138, 160, 4);
	self.dragList:setCellSpacing(13, 19);
	self.dragList:setLocation(0, 145);

	local btnInfoArr = Array();
	btnInfoArr:add({textStr = "初级", color = 3});
	btnInfoArr:add({textStr = "中级", color = 4});
	btnInfoArr:add({textStr = "高级", color = 5});
	btnInfoArr:add({textStr = "顶级", color = 6});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setLocation(0, -240, 0);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_button_006_n", "xui_common_button_006_n", 150, 56, 0.01, 1);
	self.btnList:setButtonText(0, 1, "594d4d", "8f5123", 28, 28, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
	self.btnList:setButtonItem(120, 56);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(btnInfoArr);
	self.btnList:setSelected(1);

	self.helpBtn:addClickFuntion(self, self.onHelpBtnClick);

	self:updateData();
end

function Lua_HeroCharmSlotWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroCharmSlotWindow:onBtnClick(idx, data)
	self.color = data.color;
	self:updateData();
end

function Lua_HeroCharmSlotWindow:updateData()
	local heroCharmData = DataCenter.heroCharmData;
	local arr = heroCharmData:getSlotIdArr(self.color);
	self.dragList:setArrayData(arr);

	self.levelTxt.text = LanUtil.formateStr("总等级: {1}", heroCharmData.totalLv);
	self.fightTxt.text = LanUtil.formateStr("战斗力: {1}", heroCharmData.slotForce);

	
	arr = DataCenter.attributesUtil:getAttrArrByServer(heroCharmData.slotPropList);
	self:showPropInfo(arr);
end

function Lua_HeroCharmSlotWindow:showPropInfo(arr)
	if self.propItemArr == nil then
		self.propItemArr = Array();
	end

	local count = arr:getSize();
	local num = self.propItemArr:getSize();
	local len = count > num and count or num;
	local item;
	for i = 1, len do
		item = self.propItemArr[i];
		if item == nil then
			item = Lua_HeroCharmAttrItem.new(self.content);
			item:setLocation(-240 + (i - 1) % 2 * 300, -435 - math.floor((i - 1) / 2) * 50, 0);
			self.propItemArr:add(item);
		end
		
		if i <= count then
			item:setData(arr[i]);
		end
		item:setEnable(i <= count);
	end
end

function Lua_HeroCharmSlotWindow:onHelpBtnClick()
	local tipsData = {des = "描述提示", posX = 170, posY = -316};
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end


























Lua_HeroCharmSlotItem = class("Lua_HeroCharmSlotItem", Lua_ListCell);

function Lua_HeroCharmSlotItem:ctor(p)
    self:superCall("ctor", p, "HeroCharmSlotItem_skin");
end

function Lua_HeroCharmSlotItem:buildShowItem()
    self:superCall("buildShowItem");

    self.skillIcon = Lua_SkillIconItem.new(self.content);
    self.skillIcon:setLocation(0, 0, 0);
    self.skillIcon:setSiblingIndex(0);
end

function Lua_HeroCharmSlotItem:dispose()
    if self.skillIcon ~= nil then
        self.skillIcon:dispose() 
        self.skillIcon = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_HeroCharmSlotItem:setData(slotId)
	self.data = DataCenter.heroCharmData:getSlotVo(slotId);
	local skillData;
	if self.data.levelId > 0 then
		skillData = self.data.skillData;
		self.nameTxt.text = LanUtil.formateStr("{1} Lv.{2}", skillData.name, skillData.level);
		self:showStar(self.data.level);
	else
		skillData = self.data.preLvlData.skillData;
		self.nameTxt.text = "未解锁";
		self:showStar(0);
	end
	self.skillIcon:setData(skillData);
	self.maskBg:setEnable(self.data.levelId == 0);
	self.lockIcon:setEnable(self.data.levelId == 0);
end

function Lua_HeroCharmSlotItem:showStar(starNum)
	if self.starArr == nil then
		self.starArr = Array();
	end

	local item;
	local starWidth = 44;
	local count = self.starArr:getSize();
	local len = starNum > count and starNum or count;
	for i = 1, len do
		item = self.starArr[i];
		if item == nil then
			item = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_common_label_15", 0, 0, 0, 0);
			self.starArr:add(item);
		end
		if i <= starNum then
			item:setLocation(-1 * starWidth * starNum / 2 + starWidth * (i - 1) + starWidth / 2, -45, 0);
		end
		item:setEnable(i <= starNum);
	end
end

function Lua_HeroCharmSlotItem:onPressClick()
    Lua_WindowUtil.openWin("Lua_HeroCharmSlotUpWindow", Lua_WinParam.ACTION_OPEN, self.data);
end