-- 战技 灵符Tip Window
checkRequire("Lua_HeroCharmAttrItem");
Lua_HeroCharmTipWindow = class("Lua_HeroCharmTipWindow", Lua_Window);

function Lua_HeroCharmTipWindow:ctor()
	self:superCall("ctor");

	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_HeroCharmTipWindow";
	self.skinName = "HeroCharmTipWindow_skin";
end

function Lua_HeroCharmTipWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(-135, 300);

	self.dragContainer = Lua_DragContainer.new(self.content, 460, 480, Lua_AxisDefine.Vertical);
	self.dragContainer:setRectPivot(1);
	self.dragContainer:setLocation(0, 200, 0);
end

function Lua_HeroCharmTipWindow:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self.heroCharmVo = nil;
	self:superCall("dispose");
end

function Lua_HeroCharmTipWindow:showWin(param)
	self.heroCharmVo = param.data;
	self.isShowBtns = param.isShowBtns;
	self:updateData();
end

function Lua_HeroCharmTipWindow:updateData()
	self.itemIcon:setData(self.heroCharmVo);
	self.nameTxt.text = self.heroCharmVo.colorName;
	self.levelTxt.text = LanUtil.formateStr("Lv.{1}", self.heroCharmVo.level);

	self.dragContainer:addSubContainer(Lua_HeroCharmTipPropItem, self.heroCharmVo, false, 20);
	self.dragContainer:addSubContainer(Lua_HeroCharmTipSkillItem, self.heroCharmVo, true, 20);

	if self.isShowBtns then
		local list;
		if self.heroCharmVo.heroUid > 0 then
			list = {1, 2, 4};
		else
			list = {1, 2, 3};
		end
		self:createButton(list);
	end
end

function Lua_HeroCharmTipWindow:createButton(list, addHeight)
    if self.btnArr == nil then
        self.btnArr = Array();
    end

    local len = #list;
    local num = self.btnArr:getSize();
    local count = len > num and len or num;
    local item;
    local nameStr;
    local btnWidth = 450 / len;
    for i = 1, count do
        item = self.btnArr[i];
        if item == nil then
            item = UICreate.createButton(self.content, nil, 0, 0, 141, 54);
            item:setStyle(14);
            item.txt.fontSize = 28;
            item.txt:setLocation(0, 0, 0);
            item:addClickFuntion(self, self.onBtnClick);
            self.btnArr:add(item); 
        end

        if len >= i then
            nameStr = self:getBtnName(list[i]);
            item.label = nameStr;
            item.name = list[i];
            item:setLocation((i - 1) * btnWidth - (len - 1) / 2 * btnWidth, -345, 0);
        end
        item:setEnable(len >= i);
    end
end

function Lua_HeroCharmTipWindow:getBtnName(t)
    if t == 1 then
        return "养成"; -- 养成
    elseif t == 2 then
        return "合成"; -- 合成
    elseif t == 3 then
        return "穿戴"; -- 穿戴
    elseif t == 4 then
        return "替换"; -- 替换
    end
    return "";
end

function Lua_HeroCharmTipWindow:onBtnClick(go)
    if tonumber(go.name) == 1 then
    	local param = {charmUid = self.heroCharmVo.unique_id, index = 1};
    	Lua_WindowUtil.openWin("Lua_HeroCharmDevelopWindow", Lua_WinParam.ACTION_OPEN, param);
    elseif tonumber(go.name) == 2 then
    	Lua_WindowUtil.openWin("Lua_RunesCompoundWindow", Lua_WinParam.ACTION_OPEN, 2);
    elseif tonumber(go.name) == 3 or tonumber(go.name) == 4 then
    	DataCenter.funcPathUtil:gotoFunction(1033, true)
    end
    self:hide();
end

















Lua_HeroCharmTipPropItem = class("Lua_HeroCharmTipPropItem", Lua_DragContainerItem);

function Lua_HeroCharmTipPropItem:ctor(p)
	self:superCall("ctor", p, "HeroCharmTipPropItem_skin");
end

function Lua_HeroCharmTipPropItem:buildShowItem()
	self:superCall("buildShowItem");

	self.propItemArr = Array();
end

function Lua_HeroCharmTipPropItem:dispose()
	if self.propItemArr ~= nil then
		self.propItemArr:dispose();
		self.propItemArr = nil;
	end
	self:superCall("dispose")
end

function Lua_HeroCharmTipPropItem:setData(data)
	self.data = data;

	local propArr = DataCenter.heroCharmUtil:getComAttrVoArr(data.levelId);
	local count = propArr:getSize();
	local item;
	for i = 1, count do
		item = self:getPropItem(i);
		item:setLocation(-200 + (i - 1) % 2 * 200, -45 - math.floor((i - 1) / 2) * 50, 0);
		item:setData(propArr[i]);
	end

	local addHeight = math.floor((count - 1) / 2) * 50 + 60;
	self.extraTxt:setLocation(-160, -addHeight, 0);

	propArr = DataCenter.heroCharmUtil:getSpecAttrVoArr(data.levelId);
	local limtLv;
	local index;
	for i = 1, propArr:getSize() do
		index = count + i;
		item = self:getPropItem(index);
		item:setLocation(-200 + (index - 1) % 2 * 200, -addHeight - math.floor((index - 1) / 2) * 50, 0);

		limtLv = DataCenter.heroCharmUtil:getSpecUnlockLv(data.levelId, propArr[i].id);
		item:setData(propArr[i], 1, data.level , limtLv);
	end

	addHeight = addHeight + math.floor((index - 1) / 2) * 50 + 20;
	self.addHeight = addHeight;

	local len = self.propItemArr:getSize();
	if len > index then
		for i = index + 1, len do
			self.propItemArr[i]:setEnable(false);
		end
	end
end

function Lua_HeroCharmTipPropItem:getPropItem(idx)
	local item = self.propItemArr[idx];
	if item == nil then
		item = Lua_HeroCharmAttrItem.new(self.content);
		item:setRectAnchor(1);
		item:setRectPivot(1);
		self.propItemArr:add(item);
	else
		item:setEnable(true);
	end
	return item;
end

function Lua_HeroCharmTipPropItem:getWidth()
    return 420;
end

function Lua_HeroCharmTipPropItem:getHeight()
    return self.addHeight;
end





















Lua_HeroCharmTipSkillItem = class("Lua_HeroCharmTipSkillItem", Lua_DragContainerItem);

function Lua_HeroCharmTipSkillItem:ctor(p)
	self:superCall("ctor", p, "HeroCharmTipSkillItem_skin");
end

function Lua_HeroCharmTipSkillItem:buildShowItem()
	self:superCall("buildShowItem");

	self.skillItemArr = Array();
	self.viewBtn:addClickFuntion(self, self.onViewBtnClick);
end

function Lua_HeroCharmTipSkillItem:dispose()
	if self.skillItemArr ~= nil then
		self.skillItemArr:dispose();
		self.skillItemArr = nil;
	end
	self:superCall("dispose")
end

function Lua_HeroCharmTipSkillItem:setData(data)
	self.data = data;

	local list = data.slot_list;
	local num = #list;
	local count = self.skillItemArr:getSize();
	local len = num > count and num or count;
	local skillData;
	for i = 1, len do
		item = self.skillItemArr[i];
		if item == nil then
			item = Lua_HeroCharmTipSkillDesItem.new(self.content);
			item:setRectAnchor(1);
			item:setRectPivot(1);
			item:setLocation(10, -100 - (i - 1) * 110, 0);
			self.skillItemArr:add(item);
		end

		if num >= i then
			item:setData(data:getSlotLvData(i));
		end
		item:setEnable(num >= i);
	end
	self.addHeight = num * 110;
end

function Lua_HeroCharmTipSkillItem:getWidth()
    return 420;
end

function Lua_HeroCharmTipSkillItem:getHeight()
    return self.addHeight;
end

function Lua_HeroCharmTipSkillItem:onViewBtnClick()
	Lua_WindowUtil.openWin("Lua_HeroCharmSkillShowWindow", Lua_WinParam.ACTION_OPEN);
end



















Lua_HeroCharmTipSkillDesItem = class("Lua_HeroCharmTipSkillDesItem", Lua_DisplayObject);

function Lua_HeroCharmTipSkillDesItem:ctor(p)
	self:superCall("ctor", p, "HeroCharmTipSkillDesItem_skin");
end

function Lua_HeroCharmTipSkillDesItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroCharmTipSkillDesItem:dispose()
	self.data = nil;
	self:superCall("dispose")
end

function Lua_HeroCharmTipSkillDesItem:setData(data)
	local state = data ~= nil;
	if state then
		local skillData = data.skillData;
		self.skillIcon:setAltas(skillData.altas, skillData.sprite);
		self.nameTxt.text = skillData.name;
		self.desTxt.text = skillData.des;
	end
	self.skillIcon:setEnable(state);
	self.nameTxt:setEnable(state);
	self.desTxt:setEnable(state);
end