-- 战法入口item
Lua_HeroTacticItem = class("Lua_HeroTacticItem", Lua_DisplayObject); 

function Lua_HeroTacticItem:ctor(p)
    self:superCall("ctor", p, "HeroTacticItem_skin");
end

function Lua_HeroTacticItem:buildShowItem()
    self:superCall("buildShowItem");

    self.itemBg:addClickFuntion(self, self.onBtnClick);
end

function Lua_HeroTacticItem:dispose()
    if self.starArr ~= nil then
        self.starArr:dispose();
        self.starArr = nil;
    end
    if self.showEff ~= nil then
        self.showEff:dispose();
        self.showEff = nil;
    end
    self.heroVo = nil;
    self.tacticVo = nil;
    self:superCall("dispose");
end

function Lua_HeroTacticItem:setData(heroVo)
    self.heroVo = heroVo;
    self.tacticVo = heroVo.heroTacticVo;
    if self.tacticVo ~= nil then
        self.lvlTxt.text = LanUtil.formateStr("+{1}", self.tacticVo.tacticLevel);
        self.itemIcon:setAltas(self.tacticVo.atlas, self.tacticVo.sprite);
        self.itemBg:setAltas("hero_develop_altas", "xui_zf_widget_".. (10 + self.tacticVo.color));

        self.addIcon:setEnable(false);
        self.lockIcon:setEnable(false);
        self:showStar(self.tacticVo.tacticStar);
        self:showEffect(self.tacticVo.iconEffUrl, self.tacticVo.iconEff);
    else
        self.itemBg:setAltas("hero_develop_altas", "xui_hb_widget_20");

        local isOpen = DataCenter.heroTacticData:isOpenTactic(heroVo.unique_id);
        self.addIcon:setEnable(isOpen);
        self.lockIcon:setEnable(not isOpen);
        self:showStar(0);
        self:showEffect(nil, nil);
    end
    self.itemObj:SetActive(self.tacticVo ~= nil);
end

function Lua_HeroTacticItem:showStar(num)
    if self.starArr == nil then
        self.starArr = Array();
    end

    local len = self.starArr:getSize();
    local count = len > num and len or num;
    local item;
    local starWidth = 10;
    for i = 1, count do
        item = self.starArr[i];
        if item == nil then
            item = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_label_09", 0, 0, 0, 0);
            item:setScale(0.84, 0.84, 0.84);
            self.starArr:add(item);
        end

        if num >= i then
            item:setLocation((i - 1) * starWidth - (num - 1) / 2 * starWidth, -48, 0);
        end
        item:setEnable(num >= i);
    end
end

function Lua_HeroTacticItem:showEffect(iconEffUrl, iconEff)
    if strIsNullOrEmpty(iconEff) then
        if self.showEff then
            self.showEff:setEnable(false);
        end
    else
        if self.showEff == nil then
            self.showEff = UICreate.createUIEffect(self.content, iconEffUrl, iconEff, 0, 0)
        else
            self.showEff:setUrl(iconEffUrl, iconEff);
            self.showEff:setEnable(true);
        end
    end
end

function Lua_HeroTacticItem:onBtnClick(go)
    if not DataCenter.funcOpenData:isOpened(10317, true) then
        return;
    end

    local config = DataCenter.heroTacticUtil.unlock_star;
    local star = DataCenter.heroUtil:getHeroAwakenStarByQuality(config[1], config[2]);
    if self.heroVo.star < star then
        local nameStr = DataCenter.heroUtil:getHeroQualityName(config[1], config[2]);
        OperateAlert.show(LanUtil.formateStr(792037, nameStr));
        return;
    end
    
    if self.tacticVo ~= nil then
        Lua_WindowUtil.openWin("Lua_TacticTipsWindow", Lua_WinParam.ACTION_OPEN, {data = self.tacticVo, isShowBtns = not self.heroVo.trial_state, btnType = 4, heroUid = self.heroVo.unique_id});
    else
        if self.heroVo.trial_state then
            OperateAlert.showLangValue(792042);
            return;
        end
        Lua_WindowUtil.openWin("Lua_TacticSelectWindow", Lua_WinParam.ACTION_OPEN, {selectType = 1, heroUid = self.heroVo.unique_id, showLock = true});
    end
end