-- 英雄皮肤 window
checkRequire("Lua_HeroShowBaseWindow");
checkRequire("Lua_HeroFashionPanel");
Lua_HeroFashionWindow = class("Lua_HeroFashionWindow", Lua_HeroShowBaseWindow);

function Lua_HeroFashionWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_HeroFashionWindow";
end

function Lua_HeroFashionWindow:buildPanel(go)
    self:superCall("buildPanel", go);

    self:addLuaEvent("UPDATE_ONE_HERO_INFO", self, self.updateShowHero); -- 数据更新
end

function Lua_HeroFashionWindow:buildShowItem()
    self:superCall("buildShowItem");
    
    self.lock_btn:setEnable(false);
    self.skin_btn:setEnable(false);
    self.comment_btn:setEnable(false);
    self.introduce_btn:setEnable(false);
    self.rebuild_btn:setEnable(false);
    self.share_btn:setEnable(false);
    self.sub_btn:setEnable(false);
    self.add_btn:setEnable(false);
    self.down_obj:SetActive(false);
end

function Lua_HeroFashionWindow:onScreenResize()
    self:superCall("onScreenResize");

    if self.modelScenePanel ~= nil then
        self.modelScenePanel:setRotBgDimensions(720, 815 + self.adaptHeight);
    end
end

function Lua_HeroFashionWindow:dispose()
    self.heroVo = nil;
    self:superCall("dispose");
end

function Lua_HeroFashionWindow:showWin(param)
    self:superCall("showWin", param);

    if param == nil then
        self:hide();
        return;
    end

    if param.heroVo ~= nil then
        self.heroVo = param.heroVo;
        self.isAtlas = param.isAtlas;
    else
        if param.aid ~= nil then
            self.heroVo = DataCenter.heroAtlasData:getAtlasVoById(param.aid).heroVo;
        else
            local unique_id;
            if param.arr ~= nil then
                unique_id = param.arr[param.createIdx].unique_id;
            else
                unique_id = param.unique_id;
            end
            self.heroVo = DataCenter.heroData:getItemByUniqueId(unique_id);
        end
        self.isAtlas = param.aid ~= nil;
    end

    self:updateShowHeroInfo();
end

function Lua_HeroFashionWindow:updateShowHeroInfo()
    self.name.text = self.heroVo.name;
    self.title.text = self.heroVo.title;
    self.forceNum.num = self.heroVo.heroForce;
    self.profession.text = self.heroVo.career_des;
    self.type_icon:setAltas("common_altas_3", "xui_common_attribute_"..29 + self.heroVo.campType);
    
    if self.curPanel == nil then
        self.curPanel = Lua_HeroFashionPanel.new(self.content);
        self.curPanel:setRectAnchor(9);
    end
    self.curPanel:updateHeroPanelInfo(self.heroVo, self.isAtlas, self.showData);
end

function Lua_HeroFashionWindow:updateShowHero(uid)
    if self.heroVo.unique_id == uid then
        self:updateShowHeroInfo();
    end
end