-- 英雄天赋
checkRequire("Lua_HeroGeniusAttrItem");
Lua_HeroGeniusOverviewWindow = class("Lua_HeroGeniusOverviewWindow", Lua_Window)
function Lua_HeroGeniusOverviewWindow:ctor()
	self:superCall("ctor");
	
	self.windowName = "Lua_HeroGeniusOverviewWindow";
	self.skinName = "HeroGeniusOverviewWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_HeroGeniusOverviewWindow:buildShowItem()
	self:superCall("buildShowItem");
	LuaUtil.setRectSize(self.rectTf, 711, 960);

	self.itemList = Lua_DragList.new(self.content, 625, 500, Lua_AxisDefine.Vertical);
	self.itemList:setRectAnchor(7);
	self.itemList:setLocation(0, 335, 0);
	self.itemList:setListCell(Lua_HeroGeniusOverviewItem, 625, 125, 1);
	self.itemList.tweenId = 2002;
end

function Lua_HeroGeniusOverviewWindow:dispose()
	if self.attrArr then
		self.attrArr:dispose();
		self.attrArr:clear();
		self.attrArr = nil;
	end
	if self.itemList then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroGeniusOverviewWindow:showWin(param)
	self:superCall("showWin", param);

	local heroVo = DataCenter.heroData:getItemByUniqueId(param);
	local list = DataCenter.heroGeniusData:getHeroGeniusList(heroVo.id);
	local config;
	local attrDic = {};
	for i = 1, list:getSize() do
		config = DataCenter.heroGeniusData:getGeniusConfig(list[i]);
		if heroVo.geniusLv >= config.talent_lvl then
			attrDic = DataCenter.attributesUtil:getAttrDic(config.prop, attrDic);
		end
	end
	local arr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
	if arr and arr:getSize() > 0 then
		LuaUtil.setRectSize(self.rectTf, 711, 960);
		self.winBg:SetDimensions(711, 960);
		self.titleBg_1:setEnable(true);
		self.titleText_1:setEnable(true);
		self:showAttr(arr);
	else
		LuaUtil.setRectSize(self.rectTf, 711, 760);
		self.winBg:SetDimensions(711, 760);
		self.titleBg_1:setEnable(false);
		self.titleText_1:setEnable(false);
	end

	arr = DataCenter.heroGeniusData:getHeroGeniusList(heroVo.id);
	self.itemList.customParam = param;
	self.itemList:setArrayData(arr);
	self.itemList.canDrag = not self.itemList.isTheEnd;
end

function Lua_HeroGeniusOverviewWindow:showAttr(arr)
	if self.attrArr == nil then self.attrArr = Array(); end
	local dataLen = arr:getSize();
	local len = self.attrArr:getSize();
	local maxLen = dataLen > len and dataLen or len;
	local item;
	for i = 1, maxLen do
		item = self.attrArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_HeroGeniusAttrItem.new(self.content);
				self.attrArr:add(item);
			else
				item:setEnable(true);
			end
			item:setRectAnchor(1);
			item:setLocation(-150 + ((i - 1) % 2) * 300, -185 + Mathf.Floor((i - 1) / 2) * -45, 0);
			item:setData(arr[i]);
		end
	end
end










Lua_HeroGeniusOverviewItem = class("Lua_HeroGeniusOverviewItem", Lua_ListCell)
function Lua_HeroGeniusOverviewItem:ctor(p)
	self:superCall("ctor", p, "HeroGeniusOverviewItem_skin");
end

function Lua_HeroGeniusOverviewItem:buildShowItem()
	self:superCall("buildShowItem");
	self.skillIcon:addClickFuntion(self, self.onCheckDetails);
	self.checkDetails:addClickFuntion(self, self.onCheckDetails);
end

function Lua_HeroGeniusOverviewItem:dispose()
	self.heroUid = nil;
	self:superCall("dispose");
end

function Lua_HeroGeniusOverviewItem:setCellSeqIndex(idx)
	self:superCall("setCellSeqIndex", idx);
	self.numText.text = idx;
end

function Lua_HeroGeniusOverviewItem:setCustomParam(customParam)
	self.heroUid = customParam;
end

function Lua_HeroGeniusOverviewItem:setData(geniusId)
	self.skillIcon.mouseEnable = false;
	self.nameText:setLocation(-133, 0, 0);
	self.stateText:setEnable(false);
	self.line:setEnable(false);
	self.desText:setEnable(false);
	self.checkDetails:setEnable(false);

	local data = DataCenter.heroGeniusData:getGeniusConfig(geniusId);
	local heroVo = DataCenter.heroData:getItemByUniqueId(self.heroUid);
	self.skillId = DataCenter.heroGeniusData:getHeroGeniusSkill(heroVo.unique_id, data.talent_lvl);
	local bUnlock = DataCenter.heroGeniusData:checkGeniusLvIsUnlock(data.talent_lvl, heroVo.star);
	if bUnlock then
		-- 已解锁
		if heroVo.geniusLv >= data.talent_lvl then
			-- 已激活
			if self.skillId == 0 then
				self.skillIcon:setAltas("hero_genius_atlas", "xui_tf_button_2");
				self.skillIcon:SetDimensions(44, 45);
				self.nameText:setLangValue(126097);
			else
				local skillCfg = Lua_SkillConfigData.getConfigData(self.skillId);
				self.skillIcon:setAltas(skillCfg.atlas, skillCfg.sprite);
				self.skillIcon:SetDimensions(92, 92);
				self.skillIcon.mouseEnable = true;

				self.nameText:setLocation(-115, 38, 0);
				self.nameText.text = skillCfg.name;
				self.nameText:resetSize();
				self.stateText:setEnable(true);
				self.stateText:setLocation(self.nameText.posX + self.nameText.width + 13.5, 38, 0);
				self.line:setEnable(true);
				self.desText:setEnable(true);
				self.desText.text = skillCfg.des;
				self.checkDetails:setEnable(skillCfg.bShowDetails);
			end
		else
			self.skillIcon:setAltas("hero_genius_atlas", "xui_tf_button_3");
			self.skillIcon:SetDimensions(95, 47);
			self.nameText:setLangValue(126096);
		end
	else
		self.skillIcon:setAltas("hero_genius_atlas", "xui_tf_label_1");
		self.skillIcon:SetDimensions(76, 75);
		local str = DataCenter.heroGeniusData:getGeniusLvUnlockLabel(data.talent_lvl);
		self.nameText.text = LanUtil.formateStr(126091, str);
	end
end

function Lua_HeroGeniusOverviewItem:onCheckDetails(go)
	if self.skillId == nil or self.skillId == 0 then
		return;
	end
	Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.skillId);
end