-- 半圣进阶 Panel
checkRequire("Lua_HeroUpStarCostItem");
Lua_HeroHolyHalfPanel = class("Lua_HeroHolyHalfPanel", Lua_DisplayObject);

function Lua_HeroHolyHalfPanel:ctor(p)
    self:superCall("ctor", p, "HeroHolyHalfPanel_skin");
end

function Lua_HeroHolyHalfPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.leftHeroItem = Lua_ItemIcon.new(self.content);
    self.leftHeroItem:setScale(0.85, 0.85);
    self.leftHeroItem:setLocation(-161, 239, 0);

    self.rightHeroItem = Lua_ItemIcon.new(self.content);
    self.rightHeroItem:setScale(0.85, 0.85);
    self.rightHeroItem:setLocation(169, 239, 0);

    self.dragList = Lua_DragList.new(self.content, 626, 320, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_HeroHolyHalfAttrItem, 626, 42, 1);
    self.dragList:setLocation(0, -60, 0);

    self.sureBtn:addClickFuntion(self, self.onSureBtnClick);

    self:addLuaEvent("GET_NEXT_STAR_PROP", self, self.showAttrInfo);
    self:addLuaEvent("UPDATA_SELECT_COST_HERO_NUM", self, self.updateSelectCostHeroNum);--选择材料后更新数量

    self:addLuaEvent("MONEY_UPDATE", self, self.onItemUpdate);
    self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.onItemUpdate);
end

function Lua_HeroHolyHalfPanel:dispose()
    if self.leftHeroItem ~= nil then
        self.leftHeroItem:dispose();
        self.leftHeroItem = nil;
    end
    if self.rightHeroItem ~= nil then
        self.rightHeroItem:dispose();
        self.rightHeroItem = nil;
    end
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    if self.heroCostItemArr ~= nil then
        self.heroCostItemArr:dispose();
        self.heroCostItemArr = nil;
    end
    if self.costItemArr ~= nil then
        self.costItemArr:dispose();
        self.costItemArr = nil;
    end
    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
    self.heroVo = nil;
    self.heroUpStarVo = nil;
    self:superCall("dispose");
end

function Lua_HeroHolyHalfPanel:setData(heroVo)
    self.heroVo = heroVo;
    self.heroUpStarVo = self.heroVo.heroUpStarVo;
    DataCenter.heroUpStarData:initUpStarData(self.heroVo.unique_id);
    Lua_ProxyManager.getProxy("Lua_HeroHolyProxy"):sNextStarProp(self.heroVo.unique_id);

    local leftHeroVo = Lua_HeroVo.new(self.heroVo.id);
    leftHeroVo.level = self.heroVo.level;
    leftHeroVo.quality = self.heroVo.quality;
    leftHeroVo.quality_star = self.heroVo.quality_star;
    self.leftHeroItem:setData(leftHeroVo);
    self.leftNameTxt.text = DataCenter.heroUtil:getHeroQualityName(leftHeroVo.quality, leftHeroVo.quality_star);

    local cfgData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(self.heroVo.awaken_star_id);
    local awakenData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(cfgData.next_id);
    local rightHeroVo = Lua_HeroVo.new(self.heroVo.id);
    rightHeroVo.level = self.heroVo.level;
    rightHeroVo.quality = awakenData.quality;
    rightHeroVo.quality_star = awakenData.quality_star;
    self.rightHeroItem:setData(rightHeroVo);
    self.rightNameTxt.text = DataCenter.heroUtil:getHeroQualityName(rightHeroVo.quality, rightHeroVo.quality_star);

    self:updateCost();
end

function Lua_HeroHolyHalfPanel:showAttrInfo(msg)
    local curPropVoDic = self.heroVo.heroPropVo.heroBasePropDic;
    local nextPropVoDic = DataCenter.attributesUtil:getAttrDicByServer(msg.prop_list);
    local base_attr = DataCenter.heroUtil.hero_base_attr;
    local arr = Array();
    arr:add({curFore = self.heroVo.heroForce, nextForce = msg.force});
    for i = 1, #base_attr do
        arr:add({curPropVo = curPropVoDic[base_attr[i]], nextPropVo = nextPropVoDic[base_attr[i]]});
    end
    self.dragList:setArrayData(arr);
end

function Lua_HeroHolyHalfPanel:updateCost()
    self.redDotState = DataCenter.heroHolyData:checkHalfRedPoint(self.heroVo.unique_id);
    self:showCostItem(self.heroUpStarVo.costMaterialInfo);
    self:showHeroCostItem(self.heroUpStarVo.costHeroInfo);
    self:showRedDot(self.redDotState);
end

function Lua_HeroHolyHalfPanel:onItemUpdate(dic)
    if self.heroVo == nil or self.heroUpStarVo == nil or dic == nil then return end

    local arr = self.heroUpStarVo.costMaterialInfo;
    for i = 1, arr:getSize() do
        if dic[arr[i].id] ~= nil then
            self:updateCost();
            break;
        end
    end
end

function Lua_HeroHolyHalfPanel:showCostItem(arr)
    if self.costItemArr == nil then
        self.costItemArr = Array();
    end

    local num = self.costItemArr:getSize();
    local count = arr:getSize();
    local len = num > count and num or count;
    local item;
    for i = 1, len do
        item = self.costItemArr[i];
        if item == nil then
            item = Lua_HeroHolyCostItem.new(self.content);
            self.costItemArr:add(item);
        end

        if i <= count then
            item:setData(arr[i]);
            item:setLocation(124 + (i - 1) * 170, -268, 0);
        end
        item:setEnable(i <= count);
    end
end

function Lua_HeroHolyHalfPanel:showHeroCostItem(arr)
    if self.heroCostItemArr == nil then
        self.heroCostItemArr = Array();
    end

    local num = self.heroCostItemArr:getSize();
    local count = arr:getSize();
    local len = num > count and num or count;
    local item;
    for i = 1, len do
        item = self.heroCostItemArr[i];
        if item == nil then
            item = Lua_HeroHolyHeroCostItem.new(self.content);
            self.heroCostItemArr:add(item);
        end

        if i <= count then
            --需要自动选择材料的需要筛选一次数据
            if arr[i].isAutoSelect == true then
                arr[i]:initialCostInfo();
            end
            item:setData(arr[i]);
            item:updateRedDotState(self.redDotState);
            item:setLocation(-250 + (i - 1) * 110, -295, 0);
        end
        item:setEnable(i <= count);
    end
end

function Lua_HeroHolyHalfPanel:updateSelectCostHeroNum(costMaterialsIndex)
    if self.heroCostItemArr[costMaterialsIndex] ~= nil then
        self.heroCostItemArr[costMaterialsIndex]:setSelectNum();
    end
end

function Lua_HeroHolyHalfPanel:onSureBtnClick()
    if self.clickTime ~= nil and (getTime() - self.clickTime) < 0.5 then
        return;
    end
    self.clickTime = getTime();

    if self.heroUpStarVo.life_tree_lvl > DataCenter.lifeTreeData.cur_level then
        OperateAlert.show(LanUtil.formateStr(778015,  self.heroUpStarVo.life_tree_lvl));
        return;
    end
    
    local isMeetUpStarCost = self.heroUpStarVo.isMeetUpStarCost;
    if isMeetUpStarCost ~= true then
        DataCenter.packUtil:openPathWindow(isMeetUpStarCost, false);
        return;
    end

    if DataCenter.heroUpStarData:isUpStar(self.heroUpStarVo.all_num) == true then
        if self.heroVo.star == DataCenter.heroUtil.rollback_high then
            local cfgData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(self.heroVo.awaken_star_id);
            local nextCfgData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(cfgData.next_id);
            local str = LanUtil.formateStr(778014, DataCenter.heroUtil:getHeroQualityName(nextCfgData.quality, nextCfgData.quality_star));
            local tipsData = { des = str, btnType = 1, owner = self, sureFun = self.sureBtnClick };
            Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        else
            self:sureBtnClick();
        end
    else
        OperateAlert.showLangValue(126210);
    end
end

function Lua_HeroHolyHalfPanel:sureBtnClick()
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroUpStar(self.heroVo.unique_id);
    Lua_WindowUtil.openWin("Lua_HeroHolyWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_HeroHolyHalfPanel:showRedDot(state)
    if state then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:createRedPointEff();
            self.redDotIcon:setLocation(280, -300, 0);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

























Lua_HeroHolyHalfAttrItem = class("Lua_HeroHolyHalfAttrItem", Lua_ListCell);

function Lua_HeroHolyHalfAttrItem:ctor(p)
    self:superCall("ctor", p, "HeroHolyHalfAttrItem_skin");
end

function Lua_HeroHolyHalfAttrItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroHolyHalfAttrItem:dispose()
    self:superCall("dispose");
end

function Lua_HeroHolyHalfAttrItem:setData(data)
    self.data = data;

    if data.curFore ~= nil then
        self.leftTxt.text = LanUtil.formateStr(778008, data.curFore);
        self.rightTxt.text = data.nextForce;
        self.leftTxt:setLocation(-218, -4, 0);
    else
        self.attrIcon:setAltas("common_altas_2", data.curPropVo.attr_icon_2);
        self.leftTxt.text = LanUtil.formateStr(778009, data.curPropVo.show_name, data.curPropVo.showValue);
        self.rightTxt.text = data.nextPropVo.showValue;
        self.leftTxt:setLocation(-167, -4, 0);
    end
    self.attrIcon:setEnable(data.curFore == nil);
end

function Lua_HeroHolyHalfAttrItem:setCellSeqIndex(idx)
    self:superCall("setCellSeqIndex", idx);

    local isShow = idx % 2 == 0;
    self.bg:setEnable(isShow);
end























Lua_HeroHolyCostItem = class("Lua_HeroHolyCostItem", Lua_DisplayObject);

function Lua_HeroHolyCostItem:ctor(p)
    self:superCall("ctor", p, "HeroHolyCostItem_skin");
end

function Lua_HeroHolyCostItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroHolyCostItem:dispose()
    self.data = nil;
    self:superCall("dispose");
end

function Lua_HeroHolyCostItem:setData(data)
    self.data = data;

    self.costIcon:setAltas(data.atlas, data.sprite);
    self.costTxt.text = LanUtil.formateStr(778005, data.bagNum, data.needNum);
    self.costTxt:resetSize();

    if self.costTxt.width > 125 then
        self.costBg:SetDimensions(166 + self.costTxt.width - 125, 32);
    else
        self.costBg:SetDimensions(166, 32);
    end
end



















Lua_HeroHolyHeroCostItem = class("Lua_HeroHolyHeroCostItem", Lua_HeroUpStarCostItem);

function Lua_HeroHolyHeroCostItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroHolyHeroCostItem:buildShowItem()
    self:superCall("buildShowItem");

    self.itemIcon:setScale(0.76, 0.76);

    self.add_icon:setAltas("common_altas_5", "xui_gh_jyh_label_9");
    self.add_icon:SetDimensions(56, 56);
    self.add_icon:setScale(0.4, 0.4);
    self.add_icon:setLocation(30, -30);

    self.show_value.fontName = Lua_MyUISettings.huakangFontName;
    self.show_value.fontSize = 20;
    self.show_value.colorStr = Lua_ColorDefine.transColor("674639");
    self.show_value:setLocation(0, -60, 0);
end

function Lua_HeroHolyHeroCostItem:setSelectNum()
    self:superCall("setSelectNum");

    local selectNum = DataCenter.heroUpStarData:getSelectHeroNumByIndex(self.index);
    self.add_icon:setEnable(selectNum ~= self.upStarCostVo.needNum);
    self.itemIcon.iconBg:setGray(selectNum ~= self.upStarCostVo.needNum);
    self.itemIcon.iconImg:setGray(selectNum ~= self.upStarCostVo.needNum);
    self.show_value.text = LanUtil.formateStr(778005, selectNum, self.upStarCostVo.needNum);
end