-- 圣魂 英雄材料选择 Window
Lua_HeroHolySelectCostWindow = class("Lua_HeroHolySelectCostWindow", Lua_Window);

function Lua_HeroHolySelectCostWindow:ctor()
	self:superCall("ctor");

    self.isClickClose = true;
    self.showBlackMask = true;
	self.windowName = "Lua_HeroHolySelectCostWindow";
	self.skinName = "HeroHolySelectCostWindow_skin";
end

function Lua_HeroHolySelectCostWindow:buildShowItem()
	self:superCall("buildShowItem");

    self.selectUidDic = {};

    self.dragList = Lua_DragList.new(self.content, 610, 320, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_HeroHolySelectCostItem, 106, 108, 5);
    self.dragList:setCellSpacing(15, 15);
    self.dragList:setLocation(9, 32);
    self.dragList.canLongPress = true;

    self.sub_btn:addClickFuntion(self, self.onSubClick);
    self.select_btn:addClickFuntion(self, self.onAllSelectClick);

    self:addLuaEvent("UPDATA_SELECT_COST_ITEM", self, self.updataSelectItemInfo);
end

function Lua_HeroHolySelectCostWindow:dispose()
    if self.isSureClick == nil then
        DataCenter.heroHolyData:clearStuffUidPosDic(self.data.soulType, self.data.index, self.selectUidDic);
    end

    if self.dragList ~= nil then
        self.dragList:dispose(); 
        self.dragList = nil;
    end
    self:superCall("dispose");
end

function Lua_HeroHolySelectCostWindow:showWin(param)
    self.data = param;

    self.heroUidArr = DataCenter.heroHolyData:getCostHeroArr(self.data);
    self.dragList:setArrayData(self.heroUidArr);

    self:updateSelectCostNum();
end

function Lua_HeroHolySelectCostWindow:updateSelect()
    if self.dragList ~= nil then
        local arr = self.dragList.showList;
        for i = 1, arr:getSize() do
            arr[i]:updateSelect();
        end
    end
end

function Lua_HeroHolySelectCostWindow:updateSelectCostNum()
    local selectNum = DataCenter.heroHolyData:getSelectStuffNum(self.data.soulType, self.data.index);
    self.select_num.text = LanUtil.formateStr(126215, tostring(selectNum), self.data.needNum);
end

function Lua_HeroHolySelectCostWindow:updataSelectItemInfo(unique_id) -- 选择道具数据
    self.unique_id = unique_id;
    self.hvo = DataCenter.heroData:getItemByUniqueId(unique_id);
    if DataCenter.heroHolyData:isSelectSuff(unique_id) then
        self.selectUidDic[unique_id] = 0;
        DataCenter.heroHolyData:delStuffUidPosDic(self.data.soulType, self.data.index, unique_id);
        self:updateSelect();
        self:updateSelectCostNum();
    else
        local selectNum = DataCenter.heroHolyData:getSelectStuffNum(self.data.soulType, self.data.index);
        if selectNum == self.data.needNum then
            OperateAlert.showLangValue(126208);
            return;
        else
            self:checkTips();
        end
    end
end

function Lua_HeroHolySelectCostWindow:checkTips()
    if self.hvo == nil then
        return;
    end
    if self.hvo.isUpLineup and DataCenter.heroHolyData.removeLineupUidDic[self.unique_id] ~= 1 then --是否显示下阵tips
        self:showHeroLineupTips();
        return;
    end
    if self.hvo.lock_state == true then--上锁tips
        self:showHeroUnlockTips();
        return;
    end
    self:onSubBtnClick();
end

function Lua_HeroHolySelectCostWindow:showHeroLineupTips()
    local tipData = { des = LanUtil.formateStr(126221, self.hvo.upLineupName), btnType = 1, owner = self, sureFun = self.onHeroLineup };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_HeroHolySelectCostWindow:onHeroLineup()
    local bDownLineup;
    local showName;
    bDownLineup, showName = DataCenter.heroHolyData:checkLineupNumState(self.unique_id);
    if bDownLineup then--是否可以下阵
        OperateAlert.showLangValue(126222);
        DataCenter.heroHolyData.removeLineupUidDic[self.unique_id] = 1;
    else
        if self.hvo:isInLineup(49) or self.hvo:isInLineup(50) or self.hvo:isInLineup(51) then
            OperateAlert.showLangValue(701096);
        else
            OperateAlert.show(LanUtil.formateStr(126223, showName));
        end
        return
    end
    if self.hvo.lock_state == true then--上锁tips
        self:showHeroUnlockTips();
        return;
    end
    self:onSubBtnClick();
end

function Lua_HeroHolySelectCostWindow:showHeroUnlockTips()
    local tipData = { h = 443, font_size = 26, des = LanUtil.getValue(126219), posY = 44,
        btnType = 1, owner = self, sureFun = self.sendUnlock };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_HeroHolySelectCostWindow:sendUnlock()
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLock(self.hvo.unique_id, 0);
    OperateAlert.showLangValue(126220);
    self:onSubBtnClick();
end

function Lua_HeroHolySelectCostWindow:onSubBtnClick()
    self.selectUidDic[self.unique_id] = 1;
    DataCenter.heroHolyData:addStuffUidPosDic(self.data.soulType, self.data.index, self.unique_id);
    self:updateSelect();
    self:updateSelectCostNum();
end

function Lua_HeroHolySelectCostWindow:onSubClick()
    Lua_MsgUtil.callFunc("UPDATA_HEROHOLY_COST_SELECT", self.data);
    self.isSureClick = true;
    self:hide();
end

function Lua_HeroHolySelectCostWindow:onAllSelectClick()
    local selectNum = DataCenter.heroHolyData:getSelectStuffNum(self.data.soulType, self.data.index);
    if selectNum == self.data.needNum then
        OperateAlert.showLangValue(126208);
        return;
    end

    if self.heroUidArr:getSize() == 0 then
        OperateAlert.showLangValue(126210);
        return;
    end

    if self.dragList ~= nil then
        local unique_id;
        local isSelect;
        local isSpecialState;
        local list = DataCenter.heroHolyData.removeLineupUidDic;
        for i = 1, self.heroUidArr:getSize() do
            unique_id = self.heroUidArr[i];
            isSelect = DataCenter.heroHolyData:isSelectSuff(unique_id);
            isSpecialState = false; --是否存在特殊状态，（特殊状态无法被选中）
            if string.len(unique_id) >= 20 then--万能道具
                isSpecialState = false;
            else
                local hvo = DataCenter.heroData:getItemByUniqueId(unique_id);
                if hvo ~= nil then
                    isSpecialState = hvo.lock_state or (hvo.isUpLineup and list[unique_id] == nil);
                end
            end

            if isSelect == false and isSpecialState == false then
                if selectNum < self.data.needNum then
                    selectNum = selectNum + 1;
                    self.selectUidDic[unique_id] = 1;
                    DataCenter.heroHolyData:addStuffUidPosDic(self.data.soulType, self.data.index, unique_id);
                end
            end

            if selectNum == self.data.needNum then
                break;
            end
        end
    end
    self:updateSelect();
    self:updateSelectCostNum();
end




















Lua_HeroHolySelectCostItem = class("Lua_HeroHolySelectCostItem", Lua_ListCell);
function Lua_HeroHolySelectCostItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroHolySelectCostItem:buildShowItem()
    self:superCall("buildShowItem");

    self.heroItemIcon = Lua_ItemIcon.new(self.content);
    self.heroItemIcon:setScale(0.86, 0.86);
end

function Lua_HeroHolySelectCostItem:setData(unique_id)
    self.unique_id = unique_id;
    local len = string.len(unique_id);
    if len >= 20 then
        local item_id = string.sub(unique_id,1,9);
        self.vo = Lua_ToolVo.new(item_id);
    else
        self.vo = DataCenter.heroData:getItemByUniqueId(unique_id);
    end
    self.heroItemIcon:setData(self.vo);

    self:updateSelect()
end

function Lua_HeroHolySelectCostItem:updateSelect()
    if DataCenter.heroHolyData:isSelectSuff(self.unique_id) then
        self.heroItemIcon:setDrawMask(true);
        self.heroItemIcon:setMask(false);
        self.heroItemIcon:setLock(false);
    else
        self.heroItemIcon:setDrawMask(false);
        local list = DataCenter.heroHolyData.removeLineupUidDic;
        if self.vo.lock_state == true or (self.vo.isUpLineup == true and list[self.unique_id] ~= 1) then
            self.heroItemIcon:setLock(true);
            self.heroItemIcon:setMask(true);
        else
            self.heroItemIcon:setMask(false);
            self.heroItemIcon:setLock(false);
        end
    end 
end

function Lua_HeroHolySelectCostItem:onPressClick(go)
    if self.vo == nil then
        return;
    end
    Lua_MsgUtil.callFunc("UPDATA_SELECT_COST_ITEM", self.unique_id);
end

function Lua_HeroHolySelectCostItem:onLongPressClick()
    if not Lua_WindowUtil.isWindowShowing("Lua_HeroTipsWindow") then
        Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, {heroVo = self.vo});
    end
end

function Lua_HeroHolySelectCostItem:dispose()
    if self.heroItemIcon ~= nil then
        self.heroItemIcon:dispose();
        self.heroItemIcon = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end