-- 圣魂激活 Panel
checkRequire("Lua_HeroHolyStuffCostItem");
Lua_HeroHolySoulPanel = class("Lua_HeroHolySoulPanel", Lua_DisplayObject);

function Lua_HeroHolySoulPanel:ctor(p)
    self:superCall("ctor", p, "HeroHolySoulPanel_skin");
end

function Lua_HeroHolySoulPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.itemArr = Array();

    self.skillIcon:addClickFuntion(self, self.onSkillIconClick);

    self:addLuaEvent("UPDATE_HEROHOLYSOUL_STATE", self, self.updateData);
end

function Lua_HeroHolySoulPanel:dispose()
    if self.itemArr ~= nil then
        self.itemArr:dispose();
        self.itemArr = nil;
    end
    self.heroVo = nil;
    self:superCall("dispose");
end

function Lua_HeroHolySoulPanel:setData(heroVo)
    self.heroVo = heroVo;

    if self.isFirstIn == nil then
        self.isFirstIn = true;
        DataCenter.heroHolyData:initStuffData(heroVo.unique_id);
    end

    local skillCfg = Lua_SkillConfigData.getConfigData(heroVo.holySoulSkill);
    local sprite = string.gsub(skillCfg.sprite, "_2", "_1");
    self.skillIcon:setAltas(skillCfg.atlas, sprite);

    self:updateData();
end

function Lua_HeroHolySoulPanel:updateData()
    local item;
    local lineList = {{1, 2}, 3, {4, 5}};
    local lineStr = "line";
    local state;
    for i = 1, Lua_HeroHolyData.SOUL_TYPE_NUM do
        item = self.itemArr[i];
        if item == nil then
            item = Lua_HeroHolySoulItem.new(self.content);
            item:setLocation(-208.5 + (i - 1) * 208.5, -198.5, 0);
            item:setData(self.heroVo, i)
            self.itemArr:add(item);
        else
            item:updateShow();
        end
        
        state = DataCenter.heroHolyData:holySoulState(self.heroVo.unique_id, i);
        if type(lineList[i]) == "table" then
            for j = 1, #lineList[i] do
                if state then
                    self[lineStr .. lineList[i][j]]:setAltas("hero_holy_atlas", "xui_cszl_Progress _04_f")
                else
                    self[lineStr .. lineList[i][j]]:setAltas("hero_holy_atlas", "xui_cszl_Progress-_04_b")
                end
            end
        else
            if state then
                self[lineStr .. lineList[i]]:setAltas("hero_holy_atlas", "xui_cszl_Progress _04_f")
            else
                self[lineStr .. lineList[i]]:setAltas("hero_holy_atlas", "xui_cszl_Progress-_04_b")
            end
        end
    end
end

function Lua_HeroHolySoulPanel:onSkillIconClick()
    Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.heroVo.holySoulSkill);
end





















Lua_HeroHolySoulItem = class("Lua_HeroHolySoulItem", Lua_DisplayObject);

function Lua_HeroHolySoulItem:ctor(p)
    self:superCall("ctor", p, "HeroHolySoulItem_skin");
end

function Lua_HeroHolySoulItem:buildShowItem()
    self:superCall("buildShowItem");

    self.sureBtn:addClickFuntion(self, self.onSureBtnClick);

    self:addLuaEvent("UPDATA_HEROHOLY_COST_SELECT", self, self.updateCostSelect);
end

function Lua_HeroHolySoulItem:dispose()
    if self.heroCostItemArr ~= nil then
        self.heroCostItemArr:dispose();
        self.heroCostItemArr = nil;
    end
    if self.costItemArr ~= nil then
        self.costItemArr:dispose();
        self.costItemArr = nil;
    end
    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
    self.heroVo = nil;
    self.soulVo = nil;
    self:superCall("dispose");
end

function Lua_HeroHolySoulItem:setData(heroVo, soulType)
    self.heroVo = heroVo;
    self.soulType = soulType;

    self.soulVo = DataCenter.heroHolyData:getSoulVo(heroVo.id, soulType);
    self.soulVo:initStuffInfo();
    self.titleTxt.text = self.soulVo.name;

    local vo;
    local str = "";
    for k, v in pairs(self.soulVo.prop) do
        vo = DataCenter.attributesUtil:createAttrVo(k);
        vo.value = v;
        str = str .. LanUtil.formateStr(778010, vo.show_name, vo.showValue);
    end
    self.addTxt.text = str;

    self:updateShow();
end

function Lua_HeroHolySoulItem:updateShow()
    local state = DataCenter.heroHolyData:holySoulState(self.heroVo.unique_id, self.soulType);
    if self.soulSate ~= nil and self.soulSate == state then return end
    self.soulSate = state;

    self.sureBtn:setEnable(not self.soulSate);
    self.stateIcon:setEnable(self.soulSate);

    self:showCostItem();
    self:checkRedPoint();
end

function Lua_HeroHolySoulItem:showCostItem()
    if self.heroCostItemArr == nil then
        self.heroCostItemArr = Array();
    end
    local arr = self.soulVo.heroStuffArr;
    local offsetX = self.soulVo.costStuffNum * 90 / 2 - 45;
    local item; 
    for i = 1, arr:getSize() do
        item = self.heroCostItemArr[i];
        if item == nil then
            item = Lua_HeroHolyStuffCostItem.new(self.content);
            self.heroCostItemArr:add(item);
        end
        item:setData(1, arr[i], self.soulSate);
        item:setLocation((i - 1) * 90 - offsetX, -5, 0);
    end

    if self.costItemArr == nil then
        self.costItemArr = Array();
    end
    local startIdx = arr:getSize();
    arr = self.soulVo.item_material;
    for i = 1, #arr do
        item = self.costItemArr[i];
        if item == nil then
            item = Lua_HeroHolyStuffCostItem.new(self.content);
            self.costItemArr:add(item);
        end
        item:setData(2, arr[i], self.soulSate);
        item:setLocation((startIdx + i - 1) * 90 - offsetX, -5, 0);
    end
end

function Lua_HeroHolySoulItem:updateCostSelect(data)
    if data.soulType == self.soulType then
        if self.heroCostItemArr ~= nil then
            self.heroCostItemArr[data.index]:updateShow();
        end
    end
    self:checkRedPoint();
end

function Lua_HeroHolySoulItem:onSureBtnClick()
    if self.clickTime ~= nil and (getTime() - self.clickTime) < 0.5 then
        return;
    end
    self.clickTime = getTime();

    local isItemEnough = self.soulVo.isItemEnough;
    if isItemEnough ~= true then
        DataCenter.packUtil:openPathWindow(isItemEnough, false);
        return;
    end

    if self.soulVo.isHeroEnough then
        if self.heroVo.star == DataCenter.heroUtil.rollback_high then
            local cfgData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(self.heroVo.awaken_star_id);
            local nextCfgData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(cfgData.next_id);
            local str = LanUtil.formateStr(126216,tostring(nextCfgData.quality_star));
            local tipsData = { des = str, btnType = 1, owner = self, sureFun = self.sureBtnClick };
            Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        else
            self:sureBtnClick();
        end
    else
        OperateAlert.showLangValue(126210);
    end
end

function Lua_HeroHolySoulItem:sureBtnClick()
    Lua_ProxyManager.getProxy("Lua_HeroHolyProxy"):sSoulActive(self.soulType, self.heroVo.unique_id);
    OperateAlert.showLangValue(778011);
end

function Lua_HeroHolySoulItem:checkRedPoint()
    local state = self.soulVo:checkRedPoint();
    if state and not self.soulSate then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:createRedPointEff();
            self.redDotIcon:setLocation(40, -90, 0);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end