-- 圣魂 材料消耗 Item
Lua_HeroHolyStuffCostItem = class("Lua_HeroHolyStuffCostItem", Lua_DisplayObject);

function Lua_HeroHolyStuffCostItem:ctor(p)
    self:superCall("ctor", p, "HeroHolyStuffCostItem_skin");
end

function Lua_HeroHolyStuffCostItem:buildShowItem()
    self:superCall("buildShowItem");

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setSiblingIndex(0);
    self.itemIcon:setScale(0.65, 0.65);
    self.itemIcon:setClick(self, self.onItemClick);
end

function Lua_HeroHolyStuffCostItem:dispose()
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:superCall("dispose");
end

function Lua_HeroHolyStuffCostItem:setData(itemType, data, soulState)
    self.data = data;
    self.itemType = itemType;
    self.soulState = soulState;

    self:updateShow();
end

function Lua_HeroHolyStuffCostItem:updateShow()
    local selectNum;
    local needNum;
    if self.itemType == 1 then
        local heroVo = Lua_HeroVo.new(self.data.id);
        heroVo.quality = self.data.quality;
        heroVo.quality_star = self.data.quality_star;
        heroVo.campType = self.data.campType;
        if heroVo.id == 0 then
            self.itemIcon:setData(nil);
            self.itemIcon:setTypeIcon(heroVo.campType);
            self.itemIcon:showHeroStar(heroVo.quality, heroVo.quality_star)
            self.itemIcon:setIconBg("common_altas_1", "xui_common_itembg_" .. heroVo.color);
            self.itemIcon:setIconImg("common_altas_1", "ui_common_hero_icon" .. heroVo.color);
        else
            self.itemIcon:setData(heroVo);
        end

        selectNum = DataCenter.heroHolyData:getSelectStuffNum(self.data.soulType, self.data.index);
        needNum = self.data.needNum;

        self.itemIcon:setMask(not self.soulState and selectNum < needNum);
        self.addIcon:setEnable(not self.soulState and selectNum < needNum);
    else
        self.itemVo = Lua_ToolVo.createToolVo(self.data[1]);
        self.itemIcon:setData(self.itemVo);

        selectNum = DataCenter.packData:getItemCountById(self.data[1]);
        needNum = self.data[2];
    end

    if selectNum < needNum then
        self.numTxt.text = LanUtil.formateStr(778012, numberTrans(selectNum), numberTrans(needNum));
    else
        self.numTxt.text = LanUtil.formateStr(778013, numberTrans(selectNum), numberTrans(needNum));
    end
    self.numTxt:setEnable(not self.soulState);
end

function Lua_HeroHolyStuffCostItem:onItemClick()
    if self.itemType == 1 and not self.soulState then
        Lua_WindowUtil.openWin("Lua_HeroHolySelectCostWindow", Lua_WinParam.ACTION_OPEN, self.data);
    elseif self.itemType == 2 then
        DataCenter.packUtil:showItemInfo(self.itemVo);
    end
end