-- 成圣之路 Window
checkRequire("Lua_HeroHolyTaskPanel");
checkRequire("Lua_HeroHolyHalfPanel");
checkRequire("Lua_HeroHolySoulPanel");
Lua_HeroHolyWindow = class("Lua_HeroHolyWindow", Lua_Window);

function Lua_HeroHolyWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_HeroHolyWindow";
	self.skinName = "HeroHolyWindow_skin";
end

function Lua_HeroHolyWindow:buildPanel(go)
	self:superCall("buildPanel", go);
end

function Lua_HeroHolyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.panelDic = {};

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setLocation(0, -421.5, 0);
	self.btnList:setButtonCell(Lua_HeroHolyBtnItem);
	self.btnList:setButtonItem(160, 67);
	self.btnList:setClickCallBack(self, self.onBtnClick);

	self.bgEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_cs_01", "ui_cs_01", 0, 0);

	self:addLuaEvent("SWITCH_HEROHOLY_PANEL", self, self.onSelectPanel);
	self:addLuaEvent("HEROHOLY_TASKINFO_UPDATE", self, self.updateRedPoint);
	self:addLuaEvent("UPDATE_HEROHOLYSOUL_STATE", self, self.updateRedPoint);
end

function Lua_HeroHolyWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.panelDic ~= nil then
		for k, v in pairs(self.panelDic) do
			v:dispose();
			v = nil;
		end
		self.panelDic = nil;
	end
	if self.bgEff ~= nil then
		self.bgEff:dispose();
		self.bgEff = nil;
	end
	self.heroVo = nil;
	self:superCall("dispose");
end

function Lua_HeroHolyWindow:showWin(param)
	self.heroVo = param;

	local limitDic = DataCenter.heroUtil.heroHolyTabLimit;
	self.btnInfoArr = Array();
	self.btnInfoArr:add({btnType = Lua_HeroHolyData.BEYOND, textStr = LanUtil.getValue(778000), panel = Lua_HeroHolyTaskPanel, limit = limitDic[Lua_HeroHolyData.BEYOND], heroUid = self.heroVo.unique_id});

	if self.heroVo.star < limitDic[Lua_HeroHolyData.HALF_HOLY][2] then
		self.btnInfoArr:add({btnType = Lua_HeroHolyData.HALF_HOLY, textStr = LanUtil.getValue(778001), panel = Lua_HeroHolyHalfPanel, limit = limitDic[Lua_HeroHolyData.HALF_HOLY], heroUid = self.heroVo.unique_id});
	end

	self.btnInfoArr:add({btnType = Lua_HeroHolyData.HOLY_SOUL, textStr = LanUtil.getValue(778002), panel = Lua_HeroHolySoulPanel, limit = limitDic[Lua_HeroHolyData.HOLY_SOUL], heroUid = self.heroVo.unique_id});
	self.btnList:setData(self.btnInfoArr);
	self.btnList:setSelected(1);

	self.btnBg:SetDimensions(self.btnInfoArr:getSize() * 160 + 30, 60);
end

function Lua_HeroHolyWindow:onBtnClick(idx, data)
	if self.curType ~= nil and self.curType == data.btnType then return end

	local panel;
	if self.curType ~= nil then
		panel = self.panelDic[self.curType];
		if panel ~= nil then
			panel:setEnable(false);
		end
	end

	self.curType = data.btnType;
	panel = self.panelDic[self.curType];
	if panel == nil then
		panel = data.panel.new(self.content);
		panel:setSiblingIndex(5);
		self.panelDic[self.curType] = panel;
	else
		panel:setEnable(true);
	end
	panel:setData(self.heroVo);
	self.bgEff:setEnable(self.curType ~= Lua_HeroHolyData.HALF_HOLY);
end

function Lua_HeroHolyWindow:onSelectPanel(btnType)
	local index = 1;
	for i = 1, self.btnInfoArr:getSize() do
		if self.btnInfoArr[i].btnType == btnType then
			index = i;
		end
	end

	if self.btnInfoArr[index].btnType == self.curType then
		return;
	end
	self.btnList.showList[index]:onPressClick();
end

function Lua_HeroHolyWindow:updateRedPoint()
	local arr = self.btnList.showList;
	for i = 1, arr:getSize() do
		arr[i]:checkRedPoint();
	end
end




























Lua_HeroHolyBtnItem = class("Lua_HeroHolyBtnItem", Lua_ButtonCell);

function Lua_HeroHolyBtnItem:ctor(p)
	self:superCall("ctor", p, "HeroHolyBtnItem_skin");
end

function Lua_HeroHolyBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBg.clickScale = false;
	self.btnBg:addClickFuntion(self, self.onPressClick);
end

function Lua_HeroHolyBtnItem:dispose()
	if self.redDotIcon ~= nil then
		self.redDotIcon:dispose();
		self.redDotIcon = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroHolyBtnItem:setData(data)
    self.data = data;
    self.btnTxt.text = data.textStr;

    local heroVo = DataCenter.heroData:getItemByUniqueId(data.heroUid);
    self.lcockState = heroVo.star < data.limit[1];
    self.lockIcon:setEnable(self.lcockState);
    self:checkRedPoint();
end

function Lua_HeroHolyBtnItem:onPressClick(go)
	if self.lcockState and self.data.btnType == Lua_HeroHolyData.HOLY_SOUL then
		OperateAlert.showLangValue(778003);
		return;
	end
	self:superCall("onPressClick", go);
end

function Lua_HeroHolyBtnItem:setSelected(index)
	if self.index == index then
		self.btnBg.alpha = 1;
		self.btnTxt.colorStr = Lua_ColorDefine.transColorStr("8F5123");
	else
		self.btnBg.alpha = 0;
		self.btnTxt.colorStr = Lua_ColorDefine.transColorStr("594D4D");
	end
end

function Lua_HeroHolyBtnItem:checkRedPoint()
	local state = false;
	if self.data.btnType == Lua_HeroHolyData.BEYOND then
		state = DataCenter.heroHolyData:checkTaskRedPoint(self.data.heroUid);
	elseif self.data.btnType == Lua_HeroHolyData.HALF_HOLY then
		state = DataCenter.heroHolyData:checkHalfRedPoint(self.data.heroUid);
	elseif self.data.btnType == Lua_HeroHolyData.HOLY_SOUL then
		state = DataCenter.heroHolyData:checkActiveRedPoint(self.data.heroUid);
	end

	if state then
		if self.redDotIcon == nil then
			self.redDotIcon = Lua_RedPointIcon.new(self.content);
			self.redDotIcon:createRedPointEff();
			self.redDotIcon:setLocation(70, 20, 0);
		end
		self.redDotIcon:updateRedPointShow(true);
	else
		if self.redDotIcon ~= nil then
			self.redDotIcon:updateRedPointShow(false);
		end
	end
end